SystemOrganization addCategory: #IRCBot3!
SystemOrganization addCategory: #'IRCBot3-Tests'!
SystemOrganization addCategory: #'IRCBot3-Core'!
SystemOrganization addCategory: #'IRCBot3-Handlers'!
SystemOrganization addCategory: #'IRCBot3-Client'!
SystemOrganization addCategory: #'IRCBot3-Website'!

WebApplication subclass: #LogReaderApp
	instanceVariableNames: 'formatRegex formatTemplate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

!LogReaderApp methodsFor: 'actions' stamp: 'FS 8/12/2008 14:36'!
actionMain
	self redirectToView: #log! !

!LogReaderApp methodsFor: 'views' stamp: 'FS 8/10/2008 18:34'!
addChannelSelectionBoxOn: element
	| menu |
	menu := WebMenu collection: self observee channelList selected: self observee selectedChannels.
	menu size: 1.
	menu multiple: false.
	element 
		add: menu;
		addBreak.! !

!LogReaderApp methodsFor: 'views' stamp: 'FS 8/9/2008 17:22'!
addLogOn: element 
	element addText: (self observee log).
	element addBreak.! !

!LogReaderApp methodsFor: 'utils' stamp: 'FS 8/12/2008 21:00'!
formatLog: dailyLog
	| lines |
	dailyLog log ifNil: [^'No log available for that day'].
	lines := dailyLog log subStrings: (Character lf) asString.
	^(lines inject: String new writeStream
		into: [:stream :line |
				(self formatRegex matches: line) ifTrue: [
					stream nextPutAll:  (self formatTemplate format: self formatRegex allMatches)]]) contents
		! !

!LogReaderApp methodsFor: 'accessing' stamp: 'FS 8/12/2008 20:46'!
formatRegex
	^formatRegex ifNil: [formatRegex := ReRegex newForPattern: '(.*?)\t(.*?)\t(.*)']! !

!LogReaderApp methodsFor: 'accessing' stamp: 'FS 8/12/2008 20:40'!
formatTemplate
	^formatTemplate ifNil: [ formatTemplate := 
		'<span class="logDate">{1}</span>
		<span class="logUser">{2}</span> {3} <br />']! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 18:10'!
generateChannelSelectionBox
	| menu |
	menu := WebMenu collection: self observee channelList selected: self observee selectedChannels.
	menu size: 1.
	menu multiple: false.
	
	^menu! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/12/2008 17:09'!
generateCompleteForm
	| e |
	e := WebElement new.
	e add: (self generateRowWith: 'Channel:' and: (self generateChannelSelectionBox)).
	e add: (self generateRowWith: 'Time Range:' and: (self generateTimeRangeSelectionBox)).
	e add: (self generateRowWith: nil and: 
				(WebDateInputField new aspect:  #customDate for: self observee)).
	e add: (self generateRowWith: nil and: (WebButton text: 'View log' )).
	 ^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 18:04'!
generateContainer
	^WebElement newId: #container! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 18:04'!
generateFooter
	| e |
	e := WebElement newId: #footer.
	e addText: 'Powered by '.
	e addLinkTo: 'http://www.squeak.org' text: 'Squeak Smalltalk'.
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 18:01'!
generateHeader
	| e |
	e := WebElement newId: #header.
	e addImage: '/bonoWeb/sq_logo.png'.
	e addLinkTo: self text: 'BonoWeb LogReader'.
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/12/2008 18:22'!
generateLogDivFromLogCollection: aLogCollection
	| e |
	e := WebElement newId: #'log_view'.
	aLogCollection do: [ :log |
		e addTextH2: (log channel, ' &mdash; ' , log day asString).
		e addText: (self formatLog: log)].
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/12/2008 17:51'!
generateLogView
	| e |
	e := WebElement new.
	e add: (self generateLogDivFromLogCollection: self observee log).
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 20:19'!
generateMain
	^WebElement newId: #main! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 20:17'!
generateMainMenu
	| e |
	e := WebElement newId: #menu.
	e addLinkTo: self text: 'Home' view: #main.
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/11/2008 20:32'!
generateRowWith: aLabel and: anElement
	| e |
	e := WebElement newClass: #row.
	aLabel ifNotNil: [ | text |
		text := WebText text: aLabel.
		text class: #'left_col'.
		e add: text ].
	e add: anElement.
	^e! !

!LogReaderApp methodsFor: 'element generation' stamp: 'FS 8/12/2008 15:02'!
generateTimeRangeSelectionBox
	| menu |
	menu := WebMenu 
				collection: self observee timeRangeList
				selected: self observee selectedTimeRange.
	menu size: 1.
	menu multiple: false.
	^menu! !

!LogReaderApp methodsFor: 'initialize - release' stamp: 'FS 8/11/2008 16:58'!
initPageHeaderLinks
	self initHeaders.
	self site isNil ifTrue: [^nil].
	self addMetaContentType: 'text/html; charset=UTF-8'.
	self addLinkToJavascript: self site style javascriptResource.
	"load a custom CSS stylesheet (i.e does not generate it from AIDA)"
	self addLinkToScreenStyleSheet: '/bonoWeb/design.css'! !

!LogReaderApp methodsFor: 'views' stamp: 'FS 8/12/2008 17:49'!
viewLog
	| e main |
	e := self generateContainer.
	e add: self generateHeader.
	e add: self generateMainMenu.
	main := self generateMain.
	main add: self generateLogView.
	e add: main.
	e add: self generateFooter.
	self add: e.! !

!LogReaderApp methodsFor: 'views' stamp: 'FS 8/12/2008 14:23'!
viewMain
	| e main |
	e := self generateContainer.
	e add: self generateHeader.
	e add: self generateMainMenu.
	main := self generateMain.
	main add: self generateCompleteForm.
	e add: main.
	e add: self generateFooter.
	self add: e.! !

Object subclass: #AbstractRegex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!AbstractRegex commentStamp: 'FS 7/1/2008 13:42' prior: 0!
This class provides a simple regex interface. 
Subclass it to use your favorite Regex engine.!

!AbstractRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 15:11'!
forString: aString
	^self newForPattern: aString.! !

!AbstractRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 15:11'!
newForPattern: aPattern
	self subclassResponsibility.! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 8/12/2008 20:51'!
allMatches
	"gives all the captured substrings"
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 11:52'!
matchAt: anIndex
	"should answer the captured text i.e., text inside parentheses"
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 11:51'!
matches: aString
	"should answer true / false"
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 13:34'!
pattern
	"the pattern as a string "
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 13:40'!
pattern: aString
	"should store/compile the pattern "
	self subclassResponsibility! !

!AbstractRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:53'!
setCaseInsensitive
	"should store/compile the pattern "
	self subclassResponsibility! !

AbstractRegex subclass: #ReRegex
	instanceVariableNames: 're reMatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!ReRegex commentStamp: 'FS 7/8/2008 11:35' prior: 0!
Abstract the behaviour of the RePlugin (see the Regex package)
Look at the test case to have an overview of the behaviour!

!ReRegex class methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 14:29'!
newForPattern: aPattern
	^self new re: aPattern asRegex.! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 8/12/2008 21:00'!
allMatches
	| m |
	m := OrderedCollection new.
	(1 to: self numberOfMatches) do: [:i | m add: (self matchAt: i)].
	^m
	! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 16:31'!
matchAt: anIndex
	"before getting the submatch, you must send matches:" 		
	((reMatch isNil not) and: [ anIndex <= self numberOfMatches])
		ifTrue: [^ reMatch matchAt: anIndex]
		ifFalse: [^ nil]
		! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/1/2008 14:18'!
matches: aString 
	"Does the string match the pattern?"
	self reMatch: (re search: aString).
	^self reMatch isNil not.! !

!ReRegex methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 16:00'!
numberOfMatches
	"number of captured substrings"
	reMatch 
		ifNil: [^ 0]
		ifNotNil: [^ reMatch numGroups]! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/7/2008 21:08'!
pattern
	"gives the pattern as a string (not compiled)"
	^ self re pattern.! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:50'!
pattern: aString 
	self re pattern: aString.
	self re compile.! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:49'!
re
	^ re! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 13:49'!
re: anObject
	re := anObject! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 14:18'!
reMatch
	^ reMatch! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/1/2008 14:18'!
reMatch: anObject
	reMatch := anObject! !

!ReRegex methodsFor: 'accessing' stamp: 'FS 7/8/2008 11:54'!
setCaseInsensitive
	self re setOptionForPCRECharacter: $i to: true! !

Object subclass: #AdminCommand
	instanceVariableNames: 'methodSymbol regex shortHelp longHelp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
longHelp
	^ longHelp! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
longHelp: anObject
	longHelp := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
methodSymbol
	^ methodSymbol! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
methodSymbol: anObject
	methodSymbol := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
regex
	^ regex! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
regex: anObject
	regex := anObject! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
shortHelp
	^ shortHelp! !

!AdminCommand methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:25'!
shortHelp: anObject
	shortHelp := anObject! !

Object subclass: #AdminDelayedAction
	instanceVariableNames: 'user actionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!AdminDelayedAction methodsFor: 'accessing' stamp: 'FS 7/31/2008 18:03'!
actionBlock
	^ actionBlock! !

!AdminDelayedAction methodsFor: 'accessing' stamp: 'FS 7/31/2008 18:03'!
actionBlock: anObject
	actionBlock := anObject! !

!AdminDelayedAction methodsFor: 'accessing' stamp: 'FS 7/31/2008 18:03'!
user
	^ user! !

!AdminDelayedAction methodsFor: 'accessing' stamp: 'FS 7/31/2008 18:03'!
user: anObject
	user := anObject! !

Object subclass: #BotHandler
	instanceVariableNames: 'bot active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!BotHandler commentStamp: 'FS 6/24/2008 21:18' prior: 0!
This class is an abstract class.  A subclass can define different behaviour for the bot. 
A bot has many BotHandler, each of them can be seen as functionalities for the bot.
!

BotHandler subclass: #AdminHandler
	instanceVariableNames: 'admins commands helpDictionary adminRegex delayedActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!AdminHandler commentStamp: 'FS 7/8/2008 14:40' prior: 0!
Administration handler for the bot. 
For a complete view of the available commands see #initializeCommandDictionary
Suppose the bots name is 'Anna' Commands:

- Anna, admin identify botPassword
- Anna, admin add-admin KenCausey
- Anna, admin join #squeak
- Anna admin create SayHiHandler
- Anna admin enable SayHiHandler
- Anna; admin disable SayHiHandler
- Anna, admin remove SayHiHandler

- Anna admin list admins
- Anna admin list channels
- Anna admin available handlers
- Anna admin all handlers
- Anna admin enable handlers

An admin _must_ be authentified on the network.
 !

!AdminHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/31/2008 21:31'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializeCommandDictionary.
	^handler.! !

!AdminHandler methodsFor: 'utils' stamp: 'FS 6/29/2008 15:26'!
addAdmin: nick 
	self admins add: nick! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 16:49'!
adminRegex
	^ adminRegex! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 16:49'!
adminRegex: anObject
	adminRegex := anObject! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 00:02'!
admins
	^ admins! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 00:02'!
admins: anObject
	admins := anObject! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 11:40'!
commands
	^ commands! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 11:40'!
commands: anObject
	commands := anObject! !

!AdminHandler methodsFor: 'delayed action' stamp: 'FS 7/31/2008 20:47'!
createDelayedActionFor: cmd msg: msg
	self delayedActions add: 
		(AdminDelayedAction new
			user: msg sender;
			actionBlock: [(self findCommandAndProcess: cmd msg: msg) "general admin"
					or: [self findHandlerAndProcessAdminFor: cmd msg: msg]]) "admin for a handler"! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/31/2008 22:18'!
delayedActions
	^ delayedActions ifNil: [delayedActions := OrderedCollection new]! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/31/2008 18:54'!
delayedActions: anObject
	delayedActions := anObject! !

!AdminHandler methodsFor: 'utils' stamp: 'FS 7/31/2008 20:46'!
doesCommandExists: cmd
	self commands values 
		detect: [:command | command regex matches: cmd] 
		ifNone: [^false].
	^true! !

!AdminHandler methodsFor: 'utils' stamp: 'FS 7/31/2008 19:12'!
doesHandlerAdminCommandExists: cmd
	| handler |
	handler := self findHandlerFor: cmd.
	handler ifNil: [^false].
	^handler isAdminCommand: cmd.
	! !

!AdminHandler methodsFor: 'delayed action' stamp: 'FS 7/31/2008 20:57'!
executeDelayedAction: action
	action value.! !

!AdminHandler methodsFor: 'utils' stamp: 'test 7/31/2008 20:59'!
findCommandAndProcess: cmd msg: msg
	self commands valuesDo: [:command |
		(command regex matches: cmd)  
			ifTrue: [ self perform: command methodSymbol with: msg with: command regex.
					^true ]].
	^false! !

!AdminHandler methodsFor: 'utils' stamp: 'FS 7/17/2008 15:44'!
findHandlerAndProcessAdminFor: cmd msg: msg
	| handler |
	handler := self findHandlerFor: cmd.
	handler
		ifNil: [^false] 
		ifNotNil: [^handler adminCommand: cmd from: msg]
	! !

!AdminHandler methodsFor: 'utils' stamp: 'FS 7/17/2008 16:09'!
findHandlerFor: cmd
	"cmd has the form <handler> <token1> <token2>
	e.g., 'logging start logging #squeak' "
	| wantedHandler|
	wantedHandler := self extractFirstToken: cmd.
	^self bot activeHandlers  detect: [:h | h shortName = wantedHandler] ifNone: [^nil]! !

!AdminHandler methodsFor: 'help' stamp: 'FS 8/5/2008 19:37'!
generalHelp
	| tab|
	tab := Character tab asString.
	^OrderedCollection new
		add: 'Availabe admins commands:';
		add: (self commands keys 
				inject: ''
				into: [:total :key | total , key, '/'] );
		add: 'For more information about a particular command type:';
		add: ' /msg ', self bot nick, ' help admin COMMAND';
		add: 'You can also configure each handler individually. type:';
		add: '/msg ', self bot nick, ' help admin HANDLER';
		add: 'where HANDLER can be:';
		add: (self bot activeHandlers
				inject: ''
				into: [:total :handler | total , handler shortName , '/']);
		yourself.! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 21:56'!
generateAddAdmin
	^AdminCommand new
		methodSymbol: #processAddAdminCommand:matcher: ;
		regex: (self initRegex: 'add admin (.*)');
		shortHelp: 'adds an admin for the bot';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin ADD ADMIN nickname';
				add: 'Register the given nickname as an admin for the bot'; 
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:12'!
generateDisableHandler
	^AdminCommand new
		methodSymbol: #processDisableCommand:matcher: ;
		regex: (self initRegex: '^disable (.*)');
		shortHelp: 'disables an active handler';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin DISABLE handler';
				add: 'Disable the given handler. Notice that it does NOT delete it but make it inactive';
				add: 'the handler is still loaded but wont react to any message.';
				add: 'to see which handlers are currently active see the LIST ENABLE HANDLERS command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateEnableHandler
	^AdminCommand new
		methodSymbol: #processEnableCommand:matcher: ;
		regex: (self initRegex: '^enable (.*)');
		shortHelp: 'enables an inactive handler';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin ENABLE handler';
				add: 'Enable the given handler. Notice that this command does not create a handler';
				add: 'it simple activate it if it had been deactived by a DISABLE command';
				add: 'to see which handlers are currently disabled see the LIST DISABLE HANDLERS command';
				yourself)! !

!AdminHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:06'!
generateHelpForCommand: command
	| handler |
	"admin command itself"
	self commands 
			at: command asLowercase
			ifPresent: [ :cmd | ^cmd longHelp].
	"admin command for a handler"
	handler := self findHandlerFor: (self extractFirstToken: command).
	handler ifNotNil: [^handler adminHelpFor: command].
	"nothing has matched"		
	^self generalHelp.! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateIdentify
	^AdminCommand new
		methodSymbol: #processIdentifyCommand:matcher: ;
		regex: (self initRegex: '^identify (.*)');
		shortHelp: 'identify the bot on the network';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin IDENTIFY password';
				add: 'Identify the bot against NickServ';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/16/2008 16:48'!
generateInvite
	^AdminCommand new
		methodSymbol: #processInviteCommand:matcher: ;
		regex: (self initRegex: '^invite (.*)');
		shortHelp: 'invites to a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin INVITE channel';
				add: 'invites the bot to channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateJoin
	^AdminCommand new
		methodSymbol: #processJoinCommand:matcher: ;
		regex: (self initRegex: '^join (.*)');
		shortHelp: 'joins a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin JOIN channelName';
				add: 'Tells the bot to join the given channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateLeave.
	^AdminCommand new
		methodSymbol: #processLeaveCommand:matcher: ;
		regex: (self initRegex: '^leave (.*)');
		shortHelp: 'leaves a channel';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LEAVE channelName';
				add: 'Tells the bot to leave the given channel';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListAdmins
	^AdminCommand new
		methodSymbol: #processListAdminsCommand:matcher: ;
		regex: (self initRegex: '^list admins');
		shortHelp: 'lists all admins of the bot';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ADMINS';
				add: 'Gives a list of all the bots administrators';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListAllHandlers
	^AdminCommand new
		methodSymbol: #processListAllHandlersCommand:matcher: ;
		regex: (self initRegex: '^list all handlers');
		shortHelp: 'lists all the handler the bot has';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ALL HANDLERS';
				add: 'Lists all the handlers currently attached to the bot (active and inactive)';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListChannels
	^AdminCommand new
		methodSymbol: #processListChannelsCommand:matcher: ;
		regex: (self initRegex: '^list channels');
		shortHelp: 'lists channels where the bot is present';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST CHANNELS';
				add: 'Lists the channel on which the bot is connected';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListDisabledHandlers
	^AdminCommand new
		methodSymbol: #processListDisabledHandlersCommand:matcher: ;
		regex: (self initRegex: '^list disabled handlers');
		shortHelp: 'lists inactive handlers';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST DISABLED HANDLERS';
				add: 'Lists all the disabled handlers.';
				add: 'Those handlers are present but not active (i.e., ignore all messages)';
				add: 'They can be reactivated with the ENABLE command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateListEnabledHandlers
	^AdminCommand new
		methodSymbol: #processListEnabledHandlersCommand:matcher: ;
		regex: (self initRegex: '^list enabled handlers');
		shortHelp: 'lists the active handlers';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin LIST ENABLED HANDLERS';
				add: 'Lists all the enabled handlers.';
				add: 'Those handlers can be deactivated with the DISABLE command';
				yourself)! !

!AdminHandler methodsFor: 'command generation' stamp: 'FS 7/9/2008 22:13'!
generateRemoveAdmin
	^AdminCommand new
		methodSymbol: #processRemoveAdminCommand:matcher:  ;
		regex: (self initRegex: '^remove admin (.*)');
		shortHelp: 'removes an admin';
		longHelp: 
			(OrderedCollection new 
				add: 'Syntax: /msg ', self bot nick, ' admin REMOVE ADMIN nickName';
				add: 'Removes the nickname from the admins list';
				yourself)! !

!AdminHandler methodsFor: 'help' stamp: 'FS 7/10/2008 22:38'!
help: token from: sender
	(self admins includes: sender)
		ifTrue: [ ^self generateHelpForCommand: token ]
		ifFalse: [ ^OrderedCollection new 
					add: 'You must be an admin to see the available commands';
					yourself].
! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:12'!
helpDictionary
	^ helpDictionary! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/9/2008 17:12'!
helpDictionary: anObject
	helpDictionary := anObject! !

!AdminHandler methodsFor: 'initialize-release' stamp: 'FS 7/31/2008 22:17'!
initialize
	super initialize.
	self adminRegex: (self createRegexFor: ('^admin (.*)')) setCaseInsensitive.
	self admins: OrderedCollection new.! !

!AdminHandler methodsFor: 'initialize-release' stamp: 'FS 7/13/2008 00:05'!
initializeCommandDictionary
	self commands: (Dictionary newFrom:
		{ 
			'enable' -> self generateEnableHandler.
			'disable' -> self generateDisableHandler.
			'list all handlers' -> self generateListAllHandlers.
			'list enabled handlers' -> self generateListEnabledHandlers.
			'list disabled handlers' -> self generateListDisabledHandlers.
			'join' -> self generateJoin.
			'leave' -> self generateLeave.
			'list channels' -> self generateListChannels.
			'identify' -> self generateIdentify.
			'invite' -> self generateInvite.
			'list admins' -> self generateListAdmins.
			'add admin' -> self generateAddAdmin.
			'remove admin' -> self generateRemoveAdmin})! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/31/2008 20:26'!
process318command: aServerMsg
	" ex: ':kubrick.freenode.net 318 tulipe Misolin :End of /WHOIS list.' "
	| nick |
	nick := (aServerMsg argument subStrings: ' ') at: 2.
	self removeDelayedActionsForNick: nick.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/31/2008 20:58'!
process320command: aServerMsg
	" ex: ':kubrick.freenode.net 320 tulipe fstephany :is identified to servic' "
	| nick |
	nick := (aServerMsg argument subStrings: ' ') at: 2.
	self delayedActions do: [ :action |
		(action user = nick) ifTrue: [ action actionBlock value ]].
	self removeDelayedActionsForNick: nick.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:35'!
processAddAdminCommand: msg matcher: aMatcher 
	| adminNick |
	adminNick := (aMatcher matchAt: 1) withBlanksTrimmed.
	self admins add: adminNick.
	self answerTo: msg with: adminNick , ' is now an admin'! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/31/2008 21:07'!
processDirectMessage: msg 
	((self admins includes: msg sender) and: [self adminRegex matches: msg text]) 
		ifTrue: [ | cmd |
			cmd := adminRegex matchAt: 1.
			"general admin or admin for a handler"
			((self doesCommandExists: cmd) or: [self doesHandlerAdminCommandExists: cmd])
				ifTrue: [self createDelayedActionFor: cmd msg: msg.
						self sendWhoIs: msg sender.
						^true]]. 
	^false
	! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 15:56'!
processDisableCommand: msg matcher: aMatcher 
	| answer handlerName |
	handlerName := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := handlerName, ' has been disabled'.
	(handlerName = 'adminhandler')
		ifTrue: [answer := 'You cannot disable the admin']
		ifFalse: [
			[self bot disableHandler: handlerName]
				on: Error
				do: [:error | answer :=  handlerName, ' was not found']].
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/8/2008 14:58'!
processEnableCommand: msg matcher: aMatcher 
	| handlerName answer |
	handlerName := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := handlerName, ' has been activated'.
	[self bot enableHandler: handlerName]
		on: Error
		do: [:error | answer := handlerName , ' was not found.'].
	
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:35'!
processIdentifyCommand: msg matcher: aMatcher 
	| password |
	password :=  (aMatcher matchAt: 1) withBlanksTrimmed .
	self bot identify: password.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/10/2008 15:42'!
processInviteCommand: msg matcher: aMatcher 
	| channelName |
	channelName :=  (aMatcher matchAt: 1) withBlanksTrimmed .
	self bot invite: channelName.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/31/2008 21:53'!
processJoinCommand: msg matcher: aMatcher 
	| channel |
	channel := (aMatcher matchAt: 1) withBlanksTrimmed.
	self bot joinChannel: channel.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/1/2008 15:26'!
processLeaveCommand: msg matcher: aMatcher 
	| channel |
	channel := (aMatcher matchAt: 1) withBlanksTrimmed.
	self bot leaveChannel: channel.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/9/2008 21:52'!
processListAdminsCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	self answerTo: msg with: admins asString.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:29'!
processListAllHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := self bot handlers collect: [:each | ( '  ', each shortName) ].
	self answerMultiLinesMessageTo: msg with: handlers.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 8/3/2008 16:42'!
processListChannelsCommand: msg matcher: aMatcher
	| answer |
	answer := self bot channels inject: '' into: [:s :chan | s , ' ' , chan channelName].
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:27'!
processListDisabledHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := (self bot handlers select: [:handler | handler active not]) 
		collect: [:each | ( '  ', each shortName)].
	(handlers size = 0)
		ifTrue: [self answerTo: msg with: 'There''s no disabled handlers']
		ifFalse: [self answerMultiLinesMessageTo: msg with: handlers.]
	! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/28/2008 12:27'!
processListEnabledHandlersCommand: msg matcher: aMatcher 
	"private answer to the sender -- not in the channel"
	| handlers |
	handlers := (self bot handlers select: [:handler | handler active]) 
		collect: [:each | ( '  ', each shortName) ].
	self answerMultiLinesMessageTo: msg with: handlers.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/8/2008 15:04'!
processRemoveAdminCommand: msg matcher: aMatcher
	 | nick answer |
	nick := (aMatcher matchAt: 1) withBlanksTrimmed.
	answer := nick, ' is not an admin anymore'	.
	self admins remove: nick ifAbsent: [answer := nick, ' was not admin'].
	
	self answerTo: msg with: answer.! !

!AdminHandler methodsFor: 'process messages' stamp: 'FS 7/31/2008 21:04'!
processServerMessage: aServerMsg
	(aServerMsg command = '318') "end of whois"
		ifTrue: [ self process318command: aServerMsg ].
	(aServerMsg command = '320') "is identified"
		ifTrue: [ self process320command: aServerMsg ].
	^false "chaining can continue"! !

!AdminHandler methodsFor: 'delayed action' stamp: 'FS 7/31/2008 20:26'!
removeDelayedActionsForNick: nick.
	self delayedActions: (self delayedActions reject: [ :action | action user = nick])! !

!AdminHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:14'!
shortName
	^'admin'! !

!BotHandler class methodsFor: 'as yet unclassified' stamp: 'FS 6/28/2008 12:33'!
newForBot: aBot
	^self new bot: aBot.! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 08:41'!
active
	^ active ifNil: [ active := true ].! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/28/2008 12:33'!
active: anObject
	active := anObject! !

!BotHandler methodsFor: 'administration' stamp: 'FS 7/28/2008 22:56'!
adminCommand: command from: msg
	"should be overriden by handlers which want to handle admin message"
	^false! !

!BotHandler methodsFor: 'help' stamp: 'FS 7/17/2008 15:59'!
adminHelpFor: command
	"should be overidden by subclasses"
	^OrderedCollection new add: 'Sorry... Theres no admin help available for this handler'; yourself! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/24/2008 14:30'!
amIQuotedIn: msg
	" am i quoted in the text message"
	| nick |
	nick := self bot nick.
	^(msg text findString: nick startingAt: 1 caseSensitive: false) > 0! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/9/2008 15:23'!
answerMultiLinesMessageTo: msg with: answer
	answer do: [:line |
		self answerTo: msg with: line ]! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/3/2008 16:46'!
answerMultiLinesPrivateMessageTo: msg with: answer
	answer do: [:line |
		self answerPrivateMessageTo: msg with: line ]! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/3/2008 16:15'!
answerPrivateMessageTo: msg with: answer
	"answer privately to the sender"
	self bot privMsgTo: msg sender text: answer! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/30/2008 21:43'!
answerTo: msg with: answer
	"answer to the msg. check if it is a direct or channel message"
	| recipient formattedAnswer |
	formattedAnswer := answer.
	(self bot isDirectMessage: msg)
		ifTrue: [ recipient := msg sender]
		ifFalse: [ recipient := msg recipient.
				formattedAnswer := (msg sender , ':  ', answer)]. "channel msg"
	self bot privMsgTo: recipient text: formattedAnswer.! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:33'!
bot
	^ bot! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:33'!
bot: anObject
	bot := anObject! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/1/2008 15:17'!
createRegexFor: aStringPattern
	"create a regex for a given pattern"
	^self regexClass forString: aStringPattern.! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/29/2008 08:40'!
disable
	self active: false.! !

!BotHandler methodsFor: 'administration' stamp: 'FS 8/2/2008 16:46'!
disconnect
	"tells the handler that the bot is disconnecting from the network."! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 6/29/2008 08:39'!
enable
	self active: true.! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 8/2/2008 16:45'!
extractFirstToken: aString
	" 'abbel benidorm casablanca'  -> 'abbel'  "
	[^((aString subStrings: ' ') at: 1) ] 
		on: Error do: [^'']! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 8/4/2008 21:11'!
findChannelsOfUser: nick
	"gives the list of channels in which the given nick is present".
	^self bot channels select: [:chan | chan isPresent: nick]! !

!BotHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:24'!
help: token from: sender
	"should be overidden by subclasses"
	^OrderedCollection new add: 'Sorry... Theres no help available for this handler'; yourself! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/16/2008 21:46'!
initRegex: aString
	^(self createRegexFor: aString) setCaseInsensitive.! !

!BotHandler methodsFor: 'administration' stamp: 'FS 7/31/2008 19:06'!
isAdminCommand: cmd
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/17/2008 13:02'!
processChannelActivityMessage: msg
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:00'!
processChannelMessage: msg
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:02'!
processDirectMessage: msg
	^false! !

!BotHandler methodsFor: 'process message' stamp: 'FS 7/31/2008 16:39'!
processServerMessage: aServerMsg
	^false! !

!BotHandler methodsFor: 'utilities' stamp: 'FS 7/1/2008 15:14'!
regexClass
	"set the default regex class"
	^ ReRegex! !

!BotHandler methodsFor: 'answering' stamp: 'FS 7/31/2008 21:08'!
sendWhoIs: nick
	self bot sendWhoIs: nick! !

!BotHandler methodsFor: 'accessing' stamp: 'FS 7/28/2008 12:47'!
shortName
	^self className! !

BotHandler subclass: #DicoHandler
	instanceVariableNames: 'definitions maSession persistent repositoryDirectory generalRequestPattern whatIsRequestPattern newDefinitionPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!DicoHandler commentStamp: 'FS 8/1/2008 14:25' prior: 0!
This handler contains a dictionary filled with definitions.
Suppose bot's nick is Anna:

Anna, remember <object> is <definition>
Anna, what is <object>?

The prefix 'Anna' can be omitted if the request is directly sent by private message to the bot.

By default DicoHandler is not persistent (it stores definitions in a simple dictionary).
It can switch to persistent mode with Magma. See 'persistence' protocol for more details.!

!DicoHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:14'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializePatterns.
	^handler.! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 8/2/2008 16:05'!
activeDictionary
	self persistent ifTrue: [^self persistentDictionary].
	^self definitions.! !

!DicoHandler methodsFor: 'administration' stamp: 'FS 8/2/2008 15:52'!
adminCommand: command from: msg
	| answer |
	(command = 'dico start persistence') ifTrue: [
			self enablePersistency.
			answer := 'start persistence'].
	(command = 'dico stop persistence') ifTrue: [
			self disablePersistency.
			answer := 'stop persistence'].
	msg ifNotNil: [ self answerTo: msg with: answer].! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/15/2008 16:53'!
answerDefinition: msg
	| object |
	(self whatIsRequestPattern matches: msg text) 
		ifTrue: [object := self whatIsRequestPattern matchAt: 1]
		ifFalse: [ (self generalRequestPattern matches: msg text) ifTrue: [
						object :=  self generalRequestPattern matchAt: 1]].
	object := object asLowercase withBlanksTrimmed.
	self answerDefinitionOf: object to: msg.! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 8/2/2008 16:02'!
answerDefinitionOf: object to: msg
	| definition |
	definition := self activeDictionary at: object ifAbsent: [nil].
	definition isNil
		ifTrue: [ self answerTo: msg with: ('Huh ?!!')]
		ifFalse: [ self answerTo: msg with: definition].! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/1/2008 15:46'!
createRepository
	| dir |
	dir := self repositoryDirectory.
	dir assureExistence.
	MagmaRepositoryController validateCanCreateIn: 
		(dir pathName asString asMagmaLocalLocation) .
	MagmaRepositoryController 
		create: dir pathName asString
		root: (Dictionary new).! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 8/1/2008 14:18'!
definitions
	^ definitions ifNil: [definitions := Dictionary new]! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/23/2008 23:27'!
definitions: anObject
	definitions := anObject! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/1/2008 15:04'!
deleteRepository
	| dir |
	dir := self repositoryDirectory.
	(dir exists) ifTrue: [ dir recursiveDelete ].
	self persistent: false.! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/2/2008 16:10'!
disablePersistency
	self persistent not ifTrue: [^self].
	((self maSession isNil not) and: [maSession isConnected])
		ifTrue: [ self maSession disconnectAndClose].
	self maSession: nil.
	self persistent: false.! !

!DicoHandler methodsFor: 'administration' stamp: 'FS 8/2/2008 16:47'!
disconnect
	self persistent ifTrue: [ self disablePersistency ]! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/2/2008 16:09'!
enablePersistency
	| dir |
	self persistent ifTrue: [^self].
	dir := self repositoryDirectory.
	(dir exists) ifFalse: [self createRepository].
	(self maSession isNil)
		ifTrue: [ self maSession: (MagmaSession openLocal: (dir pathName asString))].
	self maSession connect: (MagmaUser id: 'bot').
	self persistent: true.! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:45'!
generalRequestPattern
	^ generalRequestPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:45'!
generalRequestPattern: anObject
	generalRequestPattern := anObject! !

!DicoHandler methodsFor: 'help' stamp: 'FS 8/5/2008 19:39'!
help: msg from: sender
	^OrderedCollection new
		add: ('say: ', self bot nick, ' remember OBJECT is DEFINITION' );
		add: ('to add a definition and:');
		add: (self bot nick, ' what is OBJECT ?');
		add: ('or simply:');
		add: (self bot nick, ' OBJECT ?');
		add: ('to retrieve it');
		yourself.! !

!DicoHandler methodsFor: 'initialize-release' stamp: 'FS 8/1/2008 14:18'!
initialize
	super initialize.! !

!DicoHandler methodsFor: 'initialize-release' stamp: 'FS 7/28/2008 12:03'!
initializePatterns
	| p1 p2 p3 |
	p1 := '^', self bot nick, '.* what is (.*?)\s*\??\s*$'.
	p2 := '^', self bot nick, '.* remember (.*?) is (.*)'.
	p3 := '^', self bot nick, '\s*[:;.,]?\s*(.*?)\s*\??\s*$'.
	self whatIsRequestPattern: (self createRegexFor: p1) setCaseInsensitive.
	self newDefinitionPattern:  (self createRegexFor: p2) setCaseInsensitive.
	self generalRequestPattern: (self createRegexFor: p3) setCaseInsensitive.! !

!DicoHandler methodsFor: 'administration' stamp: 'FS 8/2/2008 15:46'!
isAdminCommand: cmd
	"only two admin commands"
	^(cmd = 'dico start persistence') 
		or: [cmd = 'dico stop persistence'].! !

!DicoHandler methodsFor: 'testing' stamp: 'FS 7/16/2008 14:09'!
isDefinitionRequest: text
	^(self whatIsRequestPattern matches: text) 
			or: [self generalRequestPattern matches: text].! !

!DicoHandler methodsFor: 'testing' stamp: 'FS 7/15/2008 17:13'!
isNewDefinition: text
	^self newDefinitionPattern matches: text! !

!DicoHandler methodsFor: 'testing' stamp: 'FS 8/1/2008 14:20'!
isPersistent
	^self persistent! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 8/1/2008 14:55'!
maSession
	^ maSession! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 8/1/2008 14:55'!
maSession: anObject
	maSession := anObject! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/24/2008 17:48'!
newDefinitionPattern
	^ newDefinitionPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 6/24/2008 17:48'!
newDefinitionPattern: anObject
	newDefinitionPattern := anObject! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 8/1/2008 14:24'!
persistent
	"not persistent by default"
	^ persistent ifNil: [persistent := false]! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 8/1/2008 14:20'!
persistent: anObject
	persistent := anObject! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/1/2008 15:06'!
persistentDictionary
	^self maSession root! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/16/2008 14:08'!
processChannelMessage: msg
	(self isNewDefinition: msg text)
		ifTrue: [ self saveNewDefinition: msg. 
				^true].
	(self isDefinitionRequest: msg text)
		ifTrue: [ self answerDefinition: msg.
				^true].
	^false
	
	! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:41'!
processDirectMessage: msg
	"because the name of the bot is mpaybe not present if it is a directMessage"
	msg text: (self bot nick, ' ', msg text). "can change the message because its the last on the chain"
	^self processChannelMessage: msg.! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/2/2008 15:30'!
repositoryDirectory
	^repositoryDirectory
		ifNil: [ repositoryDirectory := (FileDirectory default) directoryNamed: 'IRC-DicoRepo']
	! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/2/2008 15:29'!
repositoryDirectory: aString
	repositoryDirectory := (FileDirectory default ) directoryNamed: aString
	! !

!DicoHandler methodsFor: 'persistence' stamp: 'FS 8/1/2008 15:11'!
saveDefinitionInRepository: object value: value
	maSession commit: [ maSession root at: object put: value].! !

!DicoHandler methodsFor: 'process message' stamp: 'FS 8/2/2008 16:07'!
saveNewDefinition: msg
	| object definition |	
	object := (self newDefinitionPattern matchAt: 1) asLowercase withBlanksTrimmed.
	definition := (self newDefinitionPattern matchAt: 2) withBlanksTrimmed.
	object ifNotNil: [ 
			self persistent 
				ifTrue: [self saveDefinitionInRepository: object value: definition]
				ifFalse: [self definitions at: object put: definition].
			self answerTo: msg with: ('ok') ]! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'dico'! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:13'!
whatIsRequestPattern
	^ whatIsRequestPattern! !

!DicoHandler methodsFor: 'accessing' stamp: 'FS 7/15/2008 16:13'!
whatIsRequestPattern: anObject 
	whatIsRequestPattern := anObject! !

BotHandler subclass: #FakeHandler
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:07'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	^handler! !

!FakeHandler methodsFor: 'as yet unclassified' stamp: 'FS 6/29/2008 14:56'!
initialize
	super initialize.
	messages := OrderedCollection new.! !

!FakeHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 14:56'!
messages
	^ messages! !

!FakeHandler methodsFor: 'accessing' stamp: 'FS 6/29/2008 14:56'!
messages: anObject
	messages := anObject! !

!FakeHandler methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:15'!
processDirectMessage: msg
	messages add: msg.
	^true! !

BotHandler subclass: #HelpHandler
	instanceVariableNames: 'helpPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!HelpHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:14'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializeRegex.
	^handler! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 8/5/2008 15:51'!
help: token from: sender
	"the user has sent something like: '<botName> help' "
	| answer|
	answer := OrderedCollection new.
	answer
		add: 'Hi, im the SqueakBot : http://www.squeak.org/';
		add: ' Type: /msg ' , self bot nick , ' help HANDLER';
		add: (self bot activeHandlers 
				inject: 'where HANDLER can be: ' 
				into: [:tot :handler | tot, handler shortName, '/']).	
	^answer! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 21:11'!
helpPattern
	^ helpPattern! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 21:11'!
helpPattern: anObject
	helpPattern := anObject! !

!HelpHandler methodsFor: 'initialize-release' stamp: 'FS 7/9/2008 15:21'!
initializeRegex
	| pattern |
	pattern := '^', (self bot nick), '\s*[:;.,]?\s*help\s*([a-zA-z]*)\s*(.*)'.
	self helpPattern: (self createRegexFor: pattern) setCaseInsensitive.! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:03'!
processChannelMessage: msg 
	( self helpPattern matches: msg text)
		ifTrue: [ self processHelpWanted: msg.
				^true].
	^false! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:40'!
processDirectMessage: msg
	| copy | 
	copy := msg copy.
	copy text: (self bot nick, ': ', msg text ).
	^self processChannelMessage: copy.! !

!HelpHandler methodsFor: 'process message' stamp: 'FS 7/17/2008 16:50'!
processHelpWanted: msg
	| wantedHandler handler argument help|
	wantedHandler := (self helpPattern matchAt: 1) withBlanksTrimmed asLowercase.
	handler := self bot activeHandlers 
		detect: [:h | h shortName = wantedHandler]
		ifNone: [ self ].
	argument := self helpPattern matchAt: 2.
	help := handler help: argument from: msg sender.
	self answerMultiLinesMessageTo: msg with: help
	! !

!HelpHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'help'! !

BotHandler subclass: #LoggingHandler
	instanceVariableNames: 'channelLoggers loggerClass adminCommands handlerRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!LoggingHandler commentStamp: 'FS 7/10/2008 17:33' prior: 0!
This handler logs all the traffic of the channels on which the bot is connected.
It does not log the private direct message to the bot.
See the defaultDirectory on instance side method to know where the log files are written!

!LoggingHandler class methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:45'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	handler initializeAdminCommandsDictionary.
	handler logChannel: 'direct'.
	^handler! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 21:30'!
adminCommand: command from: msg
	| cmd |
	(self handlerRegex matches: command) ifTrue: [
		cmd := self handlerRegex matchAt: 1.
		self adminCommands valuesDo: [:adminCmd |
			(adminCmd regex matches: cmd)
				ifTrue: [self perform: adminCmd methodSymbol with: msg with: adminCmd regex.
						^true]]].
	^false! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 16:43'!
adminCommands
	^ adminCommands! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 16:43'!
adminCommands: anObject
	adminCommands := anObject! !

!LoggingHandler methodsFor: 'help' stamp: 'FS 7/17/2008 16:42'!
adminHelpFor: command
	(self handlerRegex matches: command)
		ifTrue: [ self adminCommands 
				at: (self handlerRegex matchAt: 1)
				ifPresent: [ :cmd | ^cmd longHelp]].
	^self generalAdminHelp! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 18:10'!
channelLoggers
	^ channelLoggers! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 18:10'!
channelLoggers: anObject
	channelLoggers := anObject! !

!LoggingHandler methodsFor: 'utils' stamp: 'FS 7/16/2008 15:08'!
clearLogs
	self channelLoggers do: [:logger | logger clearLogs]! !

!LoggingHandler methodsFor: 'default values' stamp: 'FS 7/12/2008 18:09'!
defaultLoggerClass
	^FileChannelLogger! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 8/2/2008 18:25'!
disconnect
	self channelLoggers values do: [:each |
		self stopLogChannel: each channel]! !

!LoggingHandler methodsFor: 'help' stamp: 'FS 8/5/2008 19:58'!
generalAdminHelp
	^OrderedCollection new
		add: ' /msg Anna admin logging COMMAND';
		add: 'where COMMAND can be:';
		add: (self adminCommands keys 
				inject: ''
				into: [:total :key | total, key, ' / ']);
		 add: 'For more information about a particular command, type:';
		add: ' /msg Anna help admin logging COMMAND';
		yourself.! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateListLoggedChannels
	^AdminCommand new
		methodSymbol: #processListLoggedChannelCommand:matcher: ;
		regex: (self initRegex: '^list logged channels');
		shortHelp: 'List all the logged channels';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging LIST LOGGED CHANNELS';
					add: 'Lists all the channels that are currently logged';
					yourself)! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateStartLogging
	^AdminCommand new
		methodSymbol: #processStartLoggingCommand:matcher: ;
		regex: (self initRegex: '^start logging (.*)');
		shortHelp: 'Starts to log a channel';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging START LOGGING channel';
					add: 'Starts to log the given channel';
					yourself)! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/17/2008 16:43'!
generateStopLogging
	^AdminCommand new
		methodSymbol: #processStopLoggingCommand:matcher: ;
		regex: (self initRegex: '^stop logging (.*)');
		shortHelp: 'Stops to log a channel';
		longHelp: (OrderedCollection new
					add:' Syntax: /msg ', self bot nick, ' admin logging STOP LOGGING channel';
					add: 'Stops to log the given channel';
					yourself)! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:42'!
handlerRegex
	^ handlerRegex! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:42'!
handlerRegex: anObject
	handlerRegex := anObject! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 8/11/2008 11:39'!
initialize
	self loggerClass: self defaultLoggerClass.
	self channelLoggers: Dictionary new.
	self logChannel: 'direct'.
	self handlerRegex: (self createRegexFor: '^logging (.*)').! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 21:52'!
initializeAdminCommandsDictionary
	self adminCommands: (Dictionary newFrom:
		{
			'list logged channels' -> self generateListLoggedChannels.
			'start logging' -> self generateStartLogging.
			'stop logging' -> self generateStopLogging })! !

!LoggingHandler methodsFor: 'initialize-release' stamp: 'FS 8/5/2008 14:56'!
initializeLoggerForBot
	self bot channels do: [:chan | self logChannel: chan channelName]! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/31/2008 19:10'!
isAdminCommand: command
	(self handlerRegex matches: command) ifTrue: [ | cmd |
		cmd := self handlerRegex matchAt: 1.
		self adminCommands values 
			detect: [:adminCmd | adminCmd regex matches: cmd ]
			ifNone: [^false].
		^true].
	
	^false! !

!LoggingHandler methodsFor: 'add - remove' stamp: 'FS 7/12/2008 19:23'!
logChannel: channel
	"creates a channelLogger for the given channel"
	self channelLoggers 
		at: channel 
		put: (self loggerClass newForChannel: channel)! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 19:20'!
loggerClass
	^ loggerClass! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/12/2008 19:20'!
loggerClass: anObject
	loggerClass := anObject! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 8/4/2008 21:21'!
processChannelActivityMessage: msg
	self channelLoggers 
		at: msg channel
		ifPresent: [:log | log logChannelActivityMessage: msg].
	"because quit messages have no channels. "
	(msg command = #quit) ifTrue: [self processQuitMessage: msg ].
	^false! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 7/13/2008 00:08'!
processChannelMessage: msg
	self channelLoggers 
		at: msg recipient 
		ifPresent: [:log | log logSimpleMessage: msg].
	
	"shouldnt stop the handlers chain"
	^false! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 8/11/2008 11:13'!
processDirectMessage: msg
	| channelMessage |
	channelMessage := msg copy.
	channelMessage recipient: 'direct'.
	self processChannelMessage: channelMessage.
	^false
	
	! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 21:54'!
processListLoggedChannelCommand: msg matcher: matcher
	| answer |
	answer := OrderedCollection new.
	answer add: 'Channels that are currently logged: '.
	(self channelLoggers size = 0)
		ifTrue: [answer add: ' None'].
	self channelLoggers do: [:logger | answer add: ('  ', logger channel)].
	self answerMultiLinesMessageTo: msg with: answer.! !

!LoggingHandler methodsFor: 'process message' stamp: 'FS 8/5/2008 15:02'!
processQuitMessage: activityMsg
	| channels |
	channels := self findChannelsOfUser: activityMsg user.
	channels do: [ :chan | 
		self channelLoggers  at: chan channelName
			ifPresent: [:log | log logChannelActivityMessage: activityMsg]].! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 17:31'!
processStartLoggingCommand: msg matcher: matcher
	| channel |
	channel := matcher matchAt: 1.
	(channel size > 1) ifTrue: [
		self logChannel: channel.
		self answerTo: msg with: ('Start to log channel ', channel)]! !

!LoggingHandler methodsFor: 'administration' stamp: 'FS 7/16/2008 18:44'!
processStopLoggingCommand: msg matcher: matcher
	| channel answer |
	channel := matcher matchAt: 1.
	answer := 'Stop to log channel ', channel.
	[self stopLogChannel: channel]
		on: Error
		do: [ answer := channel].
	self answerTo: msg with: answer! !

!LoggingHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:12'!
shortName
	^'logging'! !

!LoggingHandler methodsFor: 'add - remove' stamp: 'FS 8/12/2008 19:54'!
stopLogChannel: channel
	| logger |
	logger := self channelLoggers  at: channel.
	logger stopLogging.
	self channelLoggers removeKey: channel.! !

BotHandler subclass: #SayHiHandler
	instanceVariableNames: 'replyMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!SayHiHandler commentStamp: 'FS 7/4/2008 22:12' prior: 0!
Simply answer when it receives a direct message or when it''s quoted in a channel
!

!SayHiHandler class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:15'!
newForBot: bot
	| handler |
	handler := super newForBot: bot.
	^handler! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 6/23/2008 14:41'!
generateAnswer: msg
	^self replyMessages atRandom , ' ', msg sender.! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 7/8/2008 20:30'!
help: msg from: sender
	^OrderedCollection new add: 'This handler say hello when I see my name somewhere'! !

!SayHiHandler methodsFor: 'initialize-release' stamp: 'FS 6/22/2008 21:38'!
initialize
	super initialize.
	self initializeReplyMessages.
	! !

!SayHiHandler methodsFor: 'initialize-release' stamp: 'FS 7/7/2008 18:35'!
initializeReplyMessages
	self replyMessages: OrderedCollection new.
	self replyMessages 
			add: 'Hi';
			add: 'Hello';
			add: 'Ola';
			add: 'Salut';
			add: 'Ciao';
			add: 'Dag'.
				! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:09'!
processChannelMessage: msg
	self processMessage: msg isDirect: false! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:08'!
processDirectMessage: msg
	self processMessage: msg isDirect: true.! !

!SayHiHandler methodsFor: 'handling' stamp: 'FS 7/4/2008 21:53'!
processMessage: msg isDirect: direct
	(direct or: [self amIQuotedIn: msg])
		ifTrue: [ self answerTo: msg with: (self generateAnswer: msg) ]! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:38'!
replyMessages
	^ replyMessages! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 6/22/2008 21:38'!
replyMessages: anObject
	replyMessages := anObject! !

!SayHiHandler methodsFor: 'accessing' stamp: 'FS 7/16/2008 21:13'!
shortName
	^'sayhi'! !

Object subclass: #ChannelLogger
	instanceVariableNames: 'channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!ChannelLogger class methodsFor: 'as yet unclassified' stamp: 'FS 7/12/2008 17:33'!
newForChannel: channelName
	^self new channel: channelName.! !

!ChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:32'!
channel
	^ channel! !

!ChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:32'!
channel: anObject
	channel := anObject! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/16/2008 15:08'!
clearLogs
	self subclassResponsibility! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/17/2008 13:54'!
logChannelActivityMessage: msg
	self subclassResponsibility! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 7/12/2008 17:32'!
logSimpleMessage: msg
	self subclassResponsibility! !

!ChannelLogger methodsFor: 'logging' stamp: 'FS 8/12/2008 19:53'!
stopLogging
	self subclassResponsibility! !

ChannelLogger subclass: #FakeChannelLogger
	instanceVariableNames: 'messagesLogged activityLogged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 8/5/2008 14:43'!
activityLogged
	^ activityLogged! !

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 8/5/2008 14:43'!
activityLogged: anObject
	activityLogged := anObject! !

!FakeChannelLogger methodsFor: 'initialize-release' stamp: 'FS 8/5/2008 14:43'!
initialize
	super initialize.
	self messagesLogged: OrderedCollection new.
	self activityLogged: OrderedCollection new.! !

!FakeChannelLogger methodsFor: 'stubs' stamp: 'FS 8/5/2008 14:57'!
logChannelActivityMessage: msg
	self activityLogged add: msg.! !

!FakeChannelLogger methodsFor: 'stubs' stamp: 'FS 7/12/2008 21:10'!
logSimpleMessage: msg
	self messagesLogged add: msg.! !

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 21:09'!
messagesLogged
	^ messagesLogged! !

!FakeChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 21:09'!
messagesLogged: anObject
	messagesLogged := anObject! !

ChannelLogger subclass: #FileChannelLogger
	instanceVariableNames: 'directory stream stringTemplate dateOfStream channelsActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Handlers'!

!FileChannelLogger commentStamp: 'FS 8/2/2008 17:48' prior: 0!
This logger generates simple html output of logging in files.
Directory:
IRC-logs/#squeak/2008/July/31 -> file containing the logs of the 31th July for #squeak channel.!

!FileChannelLogger class methodsFor: 'as yet unclassified' stamp: 'FS 7/12/2008 21:50'!
newForChannel: channel
	| logger |
	logger := super newForChannel: channel.
	logger initializeStream.
	^logger! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/17/2008 14:16'!
channelsActivity
	^ channelsActivity! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/17/2008 14:16'!
channelsActivity: anObject
	channelsActivity := anObject! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 17:45'!
checkAndUpdateStream
	(self dateOfStream < Date today)
		ifTrue: [ self updateStream]! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/16/2008 15:24'!
clearLogs
	self closeStream.
	self directory recursiveDelete.! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 22:20'!
closeStream
	self stream close.! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
dateOfStream
	^ dateOfStream! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
dateOfStream: anObject
	dateOfStream := anObject! !

!FileChannelLogger methodsFor: 'default values' stamp: 'FS 7/16/2008 15:23'!
defaultDirectory
	^FileDirectory default directoryNamed: 'IRC-logs'! !

!FileChannelLogger methodsFor: 'default values' stamp: 'FS 8/11/2008 11:21'!
defaultStringTemplate
	" 1: time; 2: user 3: message"
	^'<1s><t><2s><t><3s>'! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
directory
	^ directory! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
directory: anObject
	directory := anObject! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 7/16/2008 15:23'!
directoryForDay: aDate
	" /!!\ does not assure that the directory exists !!"
	^((self directory
			directoryNamed: self channel)
			directoryNamed: aDate year asString)
			directoryNamed: aDate month name asString.! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 8/12/2008 20:26'!
formatActionMessage: msg
	" actions are ''/me'' messages . E.g.; 
	:ACTION eats a lot " 
	| str | 
	str := msg text copyFrom: 8 to: (msg text size - 1).
	^self stringTemplate 
		expandMacrosWith: Time now asString
		with: '*' 
		with: (msg sender , str)! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 8/12/2008 19:49'!
formatChannelActivityMessage: msg
	^self stringTemplate 
		expandMacrosWith: Time now asString
		with: msg user
		with: ((self channelsActivity at: msg command) value: msg)
	! !

!FileChannelLogger methodsFor: 'helper' stamp: 'FS 8/12/2008 20:25'!
formatSimpleMessage: msg
	" actions are ''/me'' messages "
	msg isActionMessage ifTrue: [^self formatActionMessage: msg].
	^self stringTemplate 
		expandMacrosWith: Time now asString
		with: msg sender 
		with: msg text! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 14:22'!
initialize
	self directory: self defaultDirectory.
	self initializeChannelActivityFormatter.! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 8/5/2008 15:12'!
initializeChannelActivityFormatter
	self channelsActivity: (Dictionary newFrom:
		{
			#join -> [:msg | ' has joined ' , msg channel ]. 
			#part -> [:msg | ' has left ' , msg channel , ' (' , msg text , ')'].
			#quit -> [:msg | ' has quitted (' , msg text , ')']
		})! !

!FileChannelLogger methodsFor: 'initialize-release' stamp: 'FS 7/16/2008 16:13'!
initializeStream
	| today |
	today := Date today.
	self stream: 
		((self directoryForDay: today)
			assureExistence;
			fileNamed: today dayOfMonth asString).
	self stream setToEnd.
	self dateOfStream: today! !

!FileChannelLogger methodsFor: 'logging' stamp: 'FS 8/5/2008 15:11'!
logChannelActivityMessage: msg
	self checkAndUpdateStream.
	self stream 
		nextPutAll: (self formatChannelActivityMessage: msg);
		nextPut: Character lf.
		! !

!FileChannelLogger methodsFor: 'logging' stamp: 'FS 8/11/2008 11:27'!
logSimpleMessage: msg
	self checkAndUpdateStream.
	self stream 
		nextPutAll: (self formatSimpleMessage: msg);
		nextPut: Character lf.! !

!FileChannelLogger methodsFor: 'logging' stamp: 'FS 8/12/2008 19:54'!
stopLogging
	self closeStream ! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
stream
	^ stream! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 7/12/2008 17:35'!
stream: anObject
	stream := anObject! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 8/2/2008 17:59'!
stringTemplate
	^ stringTemplate ifNil: [stringTemplate := self defaultStringTemplate]! !

!FileChannelLogger methodsFor: 'accessing' stamp: 'FS 8/2/2008 17:58'!
stringTemplate: anObject
	stringTemplate := anObject! !

!FileChannelLogger methodsFor: 'stream utils' stamp: 'FS 7/12/2008 17:46'!
updateStream
	self stream flush; close.
	self initializeStream.! !

Object subclass: #FakeBot
	instanceVariableNames: 'channels nick outgoingMessages directMessageSubscribers channelMessageSubscribers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FakeBot commentStamp: 'FS 6/24/2008 14:31' prior: 0!
This bot simulates the behaviour of SocBot. It is used for testing handlers!

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/7/2008 18:54'!
channelMessageSubscribers
	^ channelMessageSubscribers! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/7/2008 18:54'!
channelMessageSubscribers: anObject
	channelMessageSubscribers := anObject! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 8/5/2008 15:05'!
channels
	^channels ifNil: [
		channels := Set new 
			add:  (IRCChannel newForName: '#squeak');
			add: (IRCChannel newForName: '#aida');
			yourself]! !

!FakeBot methodsFor: 'initialize-release' stamp: 'FS 7/7/2008 21:42'!
clearOutgoingMessages
	self outgoingMessages: OrderedCollection new.! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 22:23'!
directMessageSubscribers
	^ directMessageSubscribers! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 22:23'!
directMessageSubscribers: anObject
	directMessageSubscribers := anObject! !

!FakeBot methodsFor: 'initialize-release' stamp: 'FS 7/9/2008 15:18'!
initialize
	self clearOutgoingMessages.
	self directMessageSubscribers: OrderedCollection new.
	self channelMessageSubscribers: OrderedCollection new.
	self nick: 'Anna'.! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:25'!
isDirectMessage: msg
	^msg recipient = self nick.! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 14:29'!
nick
	^ nick! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 14:29'!
nick: anObject
	nick := anObject! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 20:24'!
outgoingMessages
	^ outgoingMessages! !

!FakeBot methodsFor: 'accessing' stamp: 'FS 6/24/2008 20:24'!
outgoingMessages: anObject
	outgoingMessages := anObject! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/24/2008 18:08'!
privMsgTo: recipient text: aString 
	| message |
	message := IRCPrivateMessage 
		sender: self nick
		recipient: recipient
		text: aString.
	self outgoingMessages add: message! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/31/2008 21:39'!
sendWhoIs: aNick
	"does nothing"! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:22'!
subscribeToChannelMessages: aHandler
	self channelMessageSubscribers add: aHandler! !

!FakeBot methodsFor: 'stub methods' stamp: 'FS 7/4/2008 22:22'!
subscribeToDirectMessages: aHandler
	self directMessageSubscribers add: aHandler! !

Object subclass: #IRCAbstractMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCAbstractMessage class methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 21:16'!
extractNickFromPrefix: aString
	"e.g., extracts fstephany from
	fstephany!!~fstephany@localhost"
	| stream |
	aString ifNil: [^''].
	stream := ReadStream on: aString.
	^stream upTo: $!!! !

IRCAbstractMessage subclass: #IRCChannelActivityMessage
	instanceVariableNames: 'channel user command text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCChannelActivityMessage class methodsFor: 'instance creation' stamp: 'FS 7/17/2008 12:03'!
newForChannel: channel user: user command: command text: text
	^self new
		channel: channel;
		user: user;
		command: command;
		text: text! !

!IRCChannelActivityMessage class methodsFor: 'instance creation' stamp: 'FS 7/30/2008 21:09'!
newFromGenericMessage: msg
	| chanMsg |
	chanMsg := self new.
	chanMsg user: (self extractNickFromPrefix: msg sender).
	chanMsg command: msg command.
	(msg command = #join)
		ifTrue: [
			chanMsg channel: msg text.
			chanMsg text: '']
		ifFalse: [
			chanMsg channel: msg argument.
			chanMsg text: msg text].
	^chanMsg! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
channel
	^ channel! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
channel: anObject
	channel := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:02'!
command
	^ command! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:02'!
command: anObject
	command := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
text
	^ text! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
text: anObject
	text := anObject! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
user
	^ user! !

!IRCChannelActivityMessage methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:00'!
user: anObject
	user := anObject! !

IRCAbstractMessage subclass: #IRCPrivateMessage
	instanceVariableNames: 'sender recipient text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCPrivateMessage commentStamp: 'FS 7/24/2008 17:30' prior: 0!
Represents a simple private message!

IRCPrivateMessage subclass: #IRCNoticeMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCPrivateMessage class methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 21:15'!
newFromGenericMessage: genericMsg
	^self new
		sender: (self extractNickFromPrefix: genericMsg sender);
		recipient: genericMsg argument;
		text: genericMsg text.
	! !

!IRCPrivateMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/6/2008 17:13'!
sender: sender  recipient: recipient  text: text
	^self new
		sender: sender;
		recipient: recipient;
		text: text! !

!IRCPrivateMessage methodsFor: 'testing' stamp: 'FS 8/12/2008 20:23'!
isActionMessage
	"an action message is something sent with '/me does something' "
	^self text startsWith: ((Character value: 1) asString, 'ACTION')! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
recipient
	^ recipient! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
recipient: anObject
	recipient := anObject! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
sender
	^ sender! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
sender: anObject
	sender := anObject! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
text
	^ text! !

!IRCPrivateMessage methodsFor: 'accessing' stamp: 'FS 7/6/2008 17:12'!
text: anObject
	text := anObject! !

IRCAbstractMessage subclass: #IRCServerMessage
	instanceVariableNames: 'command argument text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCServerMessage class methodsFor: 'as yet unclassified' stamp: 'FS 7/26/2008 15:09'!
newFromGenericMessage: genericMsg
	| msg |
	msg := self new.
	msg
		command: genericMsg command;
		argument: genericMsg argument;
		text: genericMsg text.
	^msg
	! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
argument
	^ argument! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
argument: anObject
	argument := anObject! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
command
	^ command! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
command: anObject
	command := anObject! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
text
	^ text! !

!IRCServerMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 15:38'!
text: anObject
	text := anObject! !

Object subclass: #IRCChannel
	instanceVariableNames: 'channelName users ops'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCChannel commentStamp: 'FS 8/4/2008 19:54' prior: 0!
Represents an IRC Channel
Operators (Op) and normal users are kept in two different sets.

Op's have a nick starting with a @. 
Ex:  :localhost. 353 tulipe = #salonBleu :tulipe @fstephany ken john

Tells that ther are 4 users  in #salonBleu and fstephany is an Op of it.!

!IRCChannel class methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 20:21'!
newForName: channelName
	^self new channelName: channelName! !

!IRCChannel methodsFor: 'comparing' stamp: 'FS 8/2/2008 20:39'!
= anObject
	^self channelName = anObject channelName! !

!IRCChannel methodsFor: 'public lib' stamp: 'FS 8/4/2008 18:20'!
addNick: nick
	(nick first = $@ )
		ifTrue: [self addOp: nick allButFirst]
		ifFalse: [self addUser: nick].! !

!IRCChannel methodsFor: 'private' stamp: 'FS 8/4/2008 17:45'!
addOp: nick
	self ops add: nick.! !

!IRCChannel methodsFor: 'comparing' stamp: 'FS 8/2/2008 20:26'!
addUser: nick
	self users add: nick.! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/2/2008 20:21'!
channelName
	^ channelName! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/2/2008 20:21'!
channelName: anObject
	channelName := anObject! !

!IRCChannel methodsFor: 'public lib' stamp: 'FS 8/4/2008 21:54'!
isPresent: aNick
	"answer wheter or not the given nick is in the channel"
	^(self users includes: aNick) or: [self ops includes: aNick].! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/4/2008 17:44'!
ops
	^ ops ifNil: [ops := Set new]! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/4/2008 17:44'!
ops: anObject
	ops := anObject! !

!IRCChannel methodsFor: 'public lib' stamp: 'FS 8/4/2008 18:20'!
removeNick: nick
	self removeUser: nick.
	self removeOp: nick.! !

!IRCChannel methodsFor: 'private' stamp: 'FS 8/4/2008 17:45'!
removeOp: nick
	self ops remove: nick ifAbsent: []! !

!IRCChannel methodsFor: 'private' stamp: 'FS 8/2/2008 20:26'!
removeUser: nick
	self users remove: nick ifAbsent: []! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/2/2008 20:27'!
users
	^ users ifNil: [users := Set new]! !

!IRCChannel methodsFor: 'accessing' stamp: 'FS 8/2/2008 20:21'!
users: anObject
	users := anObject! !

Object subclass: #IRCClientAbstraction
	instanceVariableNames: 'profile privateMsgSubscriber channelActivityMsgSubscriber serverCommandSubscriber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientAbstraction commentStamp: 'FS 7/5/2008 20:01' prior: 0!
This class is the external interface of an IRC  client protocol.
It should satisfied any need for an IRC client (bot, graphical client, etc)!

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:46'!
channelActivityMsgSubscriber
	^ channelActivityMsgSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/17/2008 12:46'!
channelActivityMsgSubscriber: anObject
	channelActivityMsgSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/25/2008 18:57'!
channels
	self subclassResponsibility.! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 18:08'!
connectTo: aServerName 
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
disconnect
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
genericErrorString
	^'Must have subscribed before unsubscribe'! !

!IRCClientAbstraction methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 17:27'!
initialize
	super initialize.
	self initializeSubscribers.
	self profile: IRCProfile new.
	! !

!IRCClientAbstraction methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 12:48'!
initializeSubscribers
	self privateMsgSubscriber: OrderedCollection new.
	self serverCommandSubscriber: OrderedCollection new.
	self channelActivityMsgSubscriber: OrderedCollection new.! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
joinChannel: channelName
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
leaveChannel: channelName
	self subclassResponsibility.! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
nick
	^ self profile nick! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
nick: aString
	^ self profile nick: aString! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
privateMsgSubscriber
	^ privateMsgSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
privateMsgSubscriber: anObject
	privateMsgSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 19:48'!
profile
	^ profile! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 19:48'!
profile: anObject
	profile := anObject! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
realName
	^ self profile realName! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:34'!
realName: aString
	^ self profile realName: aString! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:51'!
sendCommand: aString
	"send the string _as it is_ to the server"
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 17:52'!
sendPrivateMsgTo: recipient text: text
	self subclassResponsibility! !

!IRCClientAbstraction methodsFor: 'IRC network ' stamp: 'FS 7/31/2008 13:01'!
sendWhoIs: aNick
	self subclassResponsibility.! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
serverCommandSubscriber
	^ serverCommandSubscriber! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:13'!
serverCommandSubscriber: anObject
	serverCommandSubscriber := anObject! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:42'!
subscribeToChannelActivityMsg: anObject
	"channel activity refers to the join / part / quit messages"
	self channelActivityMsgSubscriber add: anObject.! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/3/2008 19:16'!
subscribeToPrivateMsg: anObject
	" the subscriber will receive privmsg (i.e. direc and channels messages)"
	self privateMsgSubscriber add: anObject.! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:31'!
subscribeToServerCommandMsg: anObject
	"Those messages are the numerical commands sent by the server"
	self serverCommandSubscriber add: anObject! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:32'!
unsubscribeToChannelActivityMsg: anObject
	self channelActivityMsgSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
unsubscribeToPrivateMsg: anObject
	self  privateMsgSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'subscribtion management' stamp: 'FS 7/24/2008 17:33'!
unsubscribeToServerCommandMsg: anObject
	"Those messages are the numerical commands sent by the server"
	self serverCommandSubscriber remove: anObject ifAbsent: [self error: self genericErrorString]! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:33'!
userName
	^ self profile userName! !

!IRCClientAbstraction methodsFor: 'accessing' stamp: 'FS 7/26/2008 20:34'!
userName: aString
	^ self profile userName: aString! !

IRCClientAbstraction subclass: #IRCClientWrapper
	instanceVariableNames: 'connection identified serverCommands commandHandler channels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientWrapper commentStamp: 'FS 7/24/2008 18:40' prior: 0!
wrap the IRCClientConnection class!

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 20:41'!
addUsers: nickList toChannel: channelName
	| channel |
	channel := self channelWithName: channelName.
	channel ifNotNil: [
		nickList do: [:nick | channel addNick: nick]].! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 8/4/2008 20:40'!
channelWithName: aChannelName
	^self channels detect: [:chan | chan channelName = aChannelName]  ! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:35'!
channels
	^channels! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/27/2008 16:33'!
channels: anObject
	channels := anObject! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:50'!
commandHandler
	^ commandHandler! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/25/2008 18:50'!
commandHandler: anObject
	commandHandler := anObject! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/2/2008 20:27'!
confirmJoinChannel: channelName
	self channels add: (IRCChannel newForName: channelName).! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 8/5/2008 20:43'!
connectTo: aServerName 
	(self connection isConnected) 
		ifTrue: [self error: 'already connected']
		ifFalse: [ self connection connectTo: aServerName andIndent: self profile]! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 7/27/2008 17:45'!
connection
	^connection ifNil: [connection := IRCClientConnection new wrapper: self].! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 8/5/2008 21:06'!
disconnect
	self connection close.
	self reset.
	Transcript cr; show: 'IRC Disconnected'! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 16:00'!
extractChannelName: arg
	"'tulipe = #salonBleu' -> #salonBleu "
	^(arg subStrings: ' ') at: 3.! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 17:42'!
extractNicksFrom: text
	"'tulipe @fstephany ken john' -> (tulipe, fstephany, ken, john)"
	^text subStrings: ' '.
	! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 8/5/2008 20:46'!
identified
	^ identified ifNil: [identified := false]! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 8/5/2008 20:45'!
identified: anObject
	identified := anObject! !

!IRCClientWrapper methodsFor: 'initialize-release' stamp: 'FS 7/27/2008 16:44'!
initialize
	super initialize.
	self channels: OrderedCollection new.
	self initializeCommandHandler.
	"lazy init for connection instance var."! !

!IRCClientWrapper methodsFor: 'initialize-release' stamp: 'FS 8/4/2008 15:26'!
initializeCommandHandler
	self commandHandler: (Dictionary newFrom:
		{
			#privmsg -> #processPrivMsg: .
			#notice -> #processNoticeMsg:.
			#'notice auth' -> #processNoticeMsg: .
			#join -> #processChannelActivityMsg: .
			#part -> #processChannelActivityMsg: .
			#quit -> #processChannelActivityMsg: .
		})! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/5/2008 21:25'!
initializeServerCommands
	^serverCommands :=  (Dictionary newFrom:
		{
			#'353' -> #processNameReply: .
			#'433' -> #processNickNameAlreadyInUse: .
			#'376' -> #processEndOfServerMOTD: .
			#'901' -> #processLoggedIn: . "Freenode send a 901 numeric reply when identified (not other servers)"
		})! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:50'!
internalProcessChannelActivityMsg: chanMsg
	"to know that we've actually joined a channel'"
	(chanMsg command = #join) ifTrue: [self internalProcessJoin: chanMsg].
	(chanMsg command = #part) ifTrue: [self internalProcessPart: chanMsg].
	(chanMsg command = #quit) ifTrue: [self processUserQuit: chanMsg ]
	! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:49'!
internalProcessJoin: chanMsg
	(chanMsg user = self profile nick) 
		ifTrue: [self confirmJoinChannel: chanMsg channel]
		ifFalse: [self processUserJoin: chanMsg]
	! !

!IRCClientWrapper methodsFor: 'internal notice' stamp: 'FS 8/5/2008 21:21'!
internalProcessNotice: genericMsg
	"on some network, Authentification comes from Nickserv only"
	((genericMsg text startsWith: 'Password accepted') and: [genericMsg sender = 'NickServ'])
		ifTrue: [self identified: true].
	! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:49'!
internalProcessPart: chanMsg
	(chanMsg user = self profile nick)
		ifTrue: [self leaveChannel: chanMsg channel]
		ifFalse: [self processUserPart: chanMsg]
	! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 21:29'!
internalProcessServerMsg: servMsg
	"see RFC 2812 for a complete listing of the server commands ID"
	self serverCommands 
		at: servMsg command 
		ifPresent: [ :symbol |self perform: symbol with: servMsg ].
	
	! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:12'!
joinChannel: channelName 
	(self channels contains: channelName)
		ifFalse: [ self connection sendCommand: ('join ', channelName)]
	"channel is added to the channels list when we receive the confirmation from the server"! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 8/2/2008 20:43'!
leaveChannel: chanName 
	self connection sendCommand: ('part ', chanName).
	self channels: (self channels reject: [:e | e channelName = chanName])! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 8/2/2008 20:17'!
processChannelActivityMsg: genericMsg
	| chanMsg |
	chanMsg := IRCChannelActivityMessage newFromGenericMessage: genericMsg.
	self channelActivityMsgSubscriber do: [ :each | each processChannelActivityMsg: chanMsg ].
	self internalProcessChannelActivityMsg: chanMsg.! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/5/2008 20:43'!
processEndOfServerMOTD: servMsg
	"confirm that we are properly connected"
	Transcript cr; show: 'IRC Connected'.! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/5/2008 21:25'!
processLoggedIn: msg
	self identified: true.! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 8/4/2008 15:11'!
processMessage: msg 
	"process a IRCGenericMessage coming from the IRCClientConnection class"
	self commandHandler 
		at: msg command
		ifPresent: 
			[ :symbol | self perform: symbol with: msg.
			^ self ].
	msg command isAllDigits ifTrue: [ self processServerMsg: msg ]! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 17:36'!
processNameReply: servMsg
	"e.g: ':localhost. 353 tulipe = #salonBleu :tulipe @fstephany ken john' "
	| channelName nickList |
	channelName := self extractChannelName: servMsg argument.
	nickList := self extractNicksFrom: servMsg text.
	self addUsers: nickList toChannel: channelName.! !

!IRCClientWrapper methodsFor: 'internal server commands' stamp: 'FS 8/4/2008 15:39'!
processNickNameAlreadyInUse: servMsg
	self disconnect.
	self error: 'Nickname already in use'! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 8/5/2008 21:05'!
processNoticeMsg: genericMsg
	| msg |
	msg := IRCNoticeMessage newFromGenericMessage: genericMsg.
	self internalProcessNotice: msg! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 7/27/2008 17:28'!
processPrivMsg: genericMsg
	| privMsg |
	privMsg := IRCPrivateMessage newFromGenericMessage: genericMsg.
	self privateMsgSubscriber do: [ :each | each processPrivateMsg: privMsg ]! !

!IRCClientWrapper methodsFor: 'message processing' stamp: 'FS 8/2/2008 20:15'!
processServerMsg: genericMsg 
	| msg |
	msg := IRCServerMessage newFromGenericMessage: genericMsg.
	self serverCommandSubscriber do: [ :each | each processServerMsg: msg ].
	self internalProcessServerMsg: msg.! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:39'!
processUserJoin: chanMsg
	| channel |
	channel := self channels  detect: [:chan | chan channelName = chanMsg channel].
	channel ifNotNil: [ channel addNick: chanMsg user].! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:42'!
processUserPart: chanMsg
	| channel |
	channel := self channels  detect: [:chan | chan channelName = chanMsg channel].
	channel ifNotNil: [ channel removeNick: chanMsg user].! !

!IRCClientWrapper methodsFor: 'internal channel activity' stamp: 'FS 8/4/2008 21:27'!
processUserQuit: chanMsg
	"a user has quitted the network. Updates the user list for the channels in which it was present."
	self channels do: [:chan | chan removeNick: chanMsg user].! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 8/5/2008 21:08'!
reset
	"when the client is deconnected"
	self identified: false.
	self channels: OrderedCollection new.! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/27/2008 16:13'!
sendCommand: aString 
	"send the string _as it is_ to the server"
	self connection sendCommand: aString! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/31/2008 13:10'!
sendPrivateMsgTo: recipient text: text 
	self sendCommand: ('privmsg ', recipient, ' :', text)! !

!IRCClientWrapper methodsFor: 'IRC network ' stamp: 'FS 7/31/2008 21:10'!
sendWhoIs: aNick
	self sendCommand: ('whois ', aNick).! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 8/4/2008 15:14'!
serverCommands
	^ serverCommands ifNil: [ self initializeServerCommands ]! !

!IRCClientWrapper methodsFor: 'accessing' stamp: 'FS 8/4/2008 15:13'!
serverCommands: anObject
	serverCommands := anObject! !

IRCClientAbstraction subclass: #IRCConnectionWrapper
	instanceVariableNames: 'connection commandsDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCConnectionWrapper commentStamp: 'FS 7/4/2008 17:33' prior: 0!
This class wrap the behaviour of IRCConnection to be easier to use.
The ultimate goal is to get rid of IRCConnection and define a new IRCClient engine.

Some methods can certainly be pushed up to the abstract superclass.!

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:06'!
channels
	self connection 
		ifNotNil: [
			^(self connection channelObservers) 
					inject: '' 
					into: [ :chanList :chanObs | chanList , ' ', chanObs channelName]] 
		ifNil: [''].! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/17/2008 11:37'!
commandsDictionary
	^ commandsDictionary! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/17/2008 11:37'!
commandsDictionary: anObject
	commandsDictionary := anObject! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/4/2008 12:20'!
connectTo: serverName
	"See IRCConnection class for details"
	self connection 
		server: serverName;
		nick: self nick;
		fullName: self realName;
		userName: self userName;
		subscribeToProtocolMessages: self;
		openWindows;
		connect.! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:03'!
connection
	^ connection! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:03'!
connection: anObject
	connection := anObject! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/17/2008 12:15'!
convertProtocolMsgToChannelActivityMsg: msg
	"IRCProtocolMessage to IRCChannelActivityMessage"
	| channelName user text  |
	(msg prefix isNil)
		ifFalse: [ user := self extractNickFromPrefix: msg prefix ].
	channelName := msg arguments at: 1.
	(msg arguments size = 2) 
		ifTrue: [text := msg arguments at: 2]
		ifFalse: [text := ''].
	^IRCChannelActivityMessage 
		newForChannel: channelName
		user: user
		command: msg command
		text: text! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/24/2008 18:08'!
convertProtocolMsgToSimpleMsg: msg 
	"IRCProtocolMessage to IRCMessage"
	| sender recipient text |
	msg prefix isNil ifFalse: [ sender := self extractNickFromPrefix: msg prefix ].
	recipient := msg arguments at: 1.
	text := msg arguments at: 2.
	^ IRCPrivateMessage 
		sender: sender
		recipient: recipient
		text: text! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/6/2008 15:29'!
disconnect
	self connection manualDisconnect.! !

!IRCConnectionWrapper methodsFor: 'utilities' stamp: 'FS 7/3/2008 19:03'!
extractNickFromPrefix: aString
	"e.g., extracts fstephany from
	fstephany!!~fstephany@localhost"
	| stream |
	stream := ReadStream on: aString.
	^stream upTo: $!!! !

!IRCConnectionWrapper methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 17:27'!
initialize
	super initialize.
	self initializeCommandsDictionary.
	self connection: IRCConnection new.! !

!IRCConnectionWrapper methodsFor: 'initialize-release' stamp: 'FS 7/17/2008 12:18'!
initializeCommandsDictionary
	self commandsDictionary: (Dictionary newFrom:
		{ #privmsg -> #processPrivateMsg: .
			#join -> #processChannelActivityMsg: .
			#part -> #processChannelActivityMsg: .
			#quit -> #processChannelActivityMsg: })! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/17/2008 12:19'!
ircProtocolMessage: msg
	"this is sent by IRCConnection to the protocolMessages subscribers
	msg is a IRCProtocolMessage"
	self commandsDictionary 
		at: msg command
		ifPresent: [:method | self perform: method with: msg].! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 22:08'!
joinChannel: channelName
	self connection openChannelCaptured: channelName.! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 19:43'!
leaveChannel: channelName
	self connection leave: channelName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:01'!
nick
	^self profile nick! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 11:54'!
nick: anObject
	self profile nick: anObject! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/17/2008 12:58'!
processChannelActivityMsg: msg
	"see the commandsDictionary to know wich kind of messages are handled"
	| msgToForward |
	msgToForward := self convertProtocolMsgToChannelActivityMsg: msg.
	self channelActivityMsgSubscriber do: [ :each | each processChannelActivityMsg: msgToForward ]! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/6/2008 16:46'!
processPrivateMsg: msg 
	"the msg is a privmsg"
	| msgToForward |
	msgToForward := self convertProtocolMsgToSimpleMsg: msg.
	self privateMsgSubscriber do: [ :each | each processPrivateMsg: msgToForward ]! !

!IRCConnectionWrapper methodsFor: 'message processing' stamp: 'FS 7/3/2008 19:20'!
processServerCommand: msg
	"process the command from the server. Command's number can be found in RFC 2812'"
	! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:33'!
realName
	^self profile realName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 11:57'!
realName: aString
	self profile realName: aString! !

!IRCConnectionWrapper methodsFor: 'IRC network ' stamp: 'FS 7/3/2008 22:11'!
sendPrivateMsgTo: recipient text: text
	connection privmsgFrom: (self nick) to: recipient text: text! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:00'!
userName
	^self profile userName! !

!IRCConnectionWrapper methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:00'!
userName: aString
	self profile userName: aString! !

Object subclass: #IRCClientConnection
	instanceVariableNames: 'socket bytesSent pendingPing messagesToSend inBuffer wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCClientConnection commentStamp: 'FS 7/25/2008 18:01' prior: 0!
Developed for the Squeak Bot.
Handles connection to a IRC server 
/!!\ not yet thread safe

msgRegex handles message strings like:
	:kikoolol.local NOTICE AUTH :*** Looking up your hostname...
	:kikoolol.local 001 tulipe :Welcome to the KikoololNetwork Internet Relay Chat Network tulipe
	:kikoolol.local 421 tulipe /msg :Unknown command
	:fstephany!!fstephany@i.love.debian.org PRIVMSG tulipe :Hello!!
	PING :kikoolol.local
	:kikoolol.local PONG kikoolol.local :blop 
	:fstephany!!fstephany@i.love.debian.org JOIN :#salonBleu
	:fstephany!!fstephany@i.love.debian.org PART #salonBleu :byebye!

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
bytesSent
	^ bytesSent! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
bytesSent: anObject
	bytesSent := anObject! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/28/2008 21:35'!
checkFloodLimit
	" 'ping :blop' size + lf = 11 "
	(self pendingPing) ifTrue: [^false].
	(self bytesSent + self pingSize >= self floodLimit)
		ifTrue: [
			self sendPing. 
			self pendingPing: true.
			^false]
		ifFalse: [^true]
		! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/31/2008 21:15'!
close
	((self socket isNil not) and: [self socket isConnected])
		ifTrue: [
			self socket sendData: ('quit', Character lf asString).
			[self socket sendDone] whileFalse: [].
			self socket close ].
	self socket: nil.
	self reset.
	! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/28/2008 22:09'!
connectTo: server
	| addr |
	Socket initializeNetwork.
	self socket ifNotNil: [self socket destroy].
	addr := NetNameResolver addressForName: server.
	addr ifNil: [^ false].
	self socket: Socket newTCP.
	self socket connectTo: addr port: 6667.
	^ true! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/27/2008 16:40'!
connectTo: server andIndent: profile
	(self connectTo: server) ifFalse: [self error: 'cant connect'].
	self startLoop.
	self indentWithProfile: profile! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/28/2008 21:34'!
doNotReachFloodLimitWith: aString
	^(self bytesSent + self pingSize) <  self floodLimit ! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/28/2008 22:10'!
emptyMessagesToSend
	| bytes outBuffer |
	(self checkFloodLimit and: [self socket sendDone])
		ifTrue: [
			outBuffer := self generateOutBuffer.
			bytes := self socket sendData: outBuffer.
			self incrementBytesSent: bytes ]! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/29/2008 10:49'!
floodLimit
	^1500! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/28/2008 21:33'!
generateOutBuffer
	| buffer |
	buffer := ''.
	[ self messagesToSend notEmpty
		and: [self doNotReachFloodLimitWith: (buffer size + self messagesToSend first) ]] 
		whileTrue: [ 
			buffer := buffer , (self messagesToSend removeFirst) , (Character lf asString)].
	^buffer.! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
inBuffer
	^ inBuffer! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
inBuffer: anObject
	inBuffer := anObject! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/27/2008 21:12'!
incrementBytesSent: increment
	self bytesSent: (self bytesSent + increment)! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/26/2008 15:27'!
indentWithProfile: profile
	self sendCommand: ('nick ', profile nick).
	self sendCommand: ('user ', profile userName , ' * * :', profile realName).! !

!IRCClientConnection methodsFor: 'initialize-release' stamp: 'FS 7/31/2008 14:59'!
initialize
	self pendingPing: false.
	self reset.! !

!IRCClientConnection methodsFor: 'testing' stamp: 'FS 7/21/2008 17:23'!
isConnected
	^(socket isNil not) 
		and: [socket isValid]
		and: [socket isConnected]! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
messagesToSend
	^ messagesToSend! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
messagesToSend: anObject
	messagesToSend := anObject! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/27/2008 21:56'!
pendingPing
	^ pendingPing! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/27/2008 21:56'!
pendingPing: anObject
	pendingPing := anObject! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/28/2008 21:35'!
pingSize
	" 'ping :blop' size + lf = 11 "
	^11! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/21/2008 18:09'!
processIO
	"dont use it manually !! See startLoop"
	(self isConnected) ifFalse: [self error: 'Must be connected'].
	self emptyMessagesToSend.
	self receiveMessages.
	^true.! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/30/2008 19:17'!
processPingPongMessage: aMsg
	(aMsg command = #ping)
		ifTrue: [self replyToPing: aMsg]
		ifFalse: [self processPong: aMsg]! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 22:12'!
processPong: aMsg
	"reset the counter."
	self bytesSent: 0.
	self pendingPing: false.! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/31/2008 14:53'!
processRawMessage: msgString
	"only forward interesting messages to the wrapper"
	| msg |
	msg := IRCGenericMessage  newFromString: msgString.
	msg ifNil: [^self].
	((msg command = #ping) or: [msg command = #pong])
		ifTrue: [self processPingPongMessage: msg] "process ping/pong internally"
		ifFalse: [self wrapper processMessage: msg]. "send other msgs to the upper layer"
	Transcript cr; show: msgString! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/24/2008 17:18'!
receiveMessages
	| idx msgText |
	[ socket dataAvailable]
		whileTrue: [ self inBuffer: (self inBuffer , socket receiveData) ].	
	[idx := self inBuffer indexOf: Character lf. idx > 0]
		whileTrue: [
			msgText  := self inBuffer copyFrom: 1 to: idx.
			self processRawMessage: msgText.
			self inBuffer: (self inBuffer copyFrom: (idx +1) to: self inBuffer size)]
	! !

!IRCClientConnection methodsFor: 'message processing' stamp: 'FS 7/27/2008 17:34'!
replyToPing: aMsg
	self sendCommand: ('pong :', aMsg text)! !

!IRCClientConnection methodsFor: 'initialize-release' stamp: 'FS 7/26/2008 15:42'!
reset
	self bytesSent: 0.
	self messagesToSend: OrderedCollection new.
	self inBuffer: ''.! !

!IRCClientConnection methodsFor: 'connection' stamp: 'FS 7/24/2008 16:56'!
sendCommand: aStringCommand
	"the command will be sent _as it is_ to the server"
	self messagesToSend addLast: aStringCommand.! !

!IRCClientConnection methodsFor: 'antiflood' stamp: 'FS 7/27/2008 22:22'!
sendPing
	| bytes |
	bytes :=self socket sendData: ('ping :blop', (Character lf asString)).! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
socket
	^ socket! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/20/2008 19:37'!
socket: anObject
	socket := anObject! !

!IRCClientConnection methodsFor: 'network IO' stamp: 'FS 7/31/2008 21:14'!
startLoop.
	[ 
		[self isConnected] whileTrue: [
			self processIO.
			(Delay forMilliseconds: 50) wait]
	] forkAt: (Processor userBackgroundPriority) named: 'IRCbot loop'
	! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/24/2008 18:38'!
wrapper
	^ wrapper! !

!IRCClientConnection methodsFor: 'accessing' stamp: 'FS 7/24/2008 18:38'!
wrapper: anObject
	wrapper := anObject! !

Object subclass: #IRCClientProfile
	instanceVariableNames: 'nick realName userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!IRCClientProfile class methodsFor: 'as yet unclassified' stamp: 'FS 7/3/2008 18:17'!
newWithNick: aNick userName: user realName: real
	^self new
		nick: aNick;
		userName: user;
		realName: real.! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
nick
	^ nick! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
nick: anObject
	nick := anObject! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
realName
	^ realName! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
realName: anObject
	realName := anObject! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
userName
	^ userName! !

!IRCClientProfile methodsFor: 'accessing' stamp: 'FS 7/3/2008 18:14'!
userName: anObject
	userName := anObject! !

Object subclass: #IRCGenericMessage
	instanceVariableNames: 'sender command argument text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

IRCGenericMessage class
	instanceVariableNames: 'msgRegex msgPingNoticeRegex'!

!IRCGenericMessage commentStamp: 'FS 7/27/2008 16:18' prior: 0!
This is a basic representation of a IRC message. 
It _shouldnt_ be used outside the IRCClientConnection class.!

IRCGenericMessage class
	instanceVariableNames: 'msgRegex msgPingNoticeRegex'!

!IRCGenericMessage class methodsFor: 'regex' stamp: 'FS 7/31/2008 14:55'!
msgPingNoticeRegex
	msgPingNoticeRegex ifNil: [ self resetPingNoticeRegex ].
	^msgPingNoticeRegex.! !

!IRCGenericMessage class methodsFor: 'regex' stamp: 'FS 7/31/2008 14:55'!
msgRegex
	msgRegex ifNil: [ self resetMsgRegex ].
	^msgRegex.! !

!IRCGenericMessage class methodsFor: 'instance creation' stamp: 'FS 8/4/2008 15:26'!
newFromString: msgString
	(self msgRegex matches: msgString)
		ifTrue: [ 
			^self new
				sender: (self msgRegex matchAt: 1);
				command: (self msgRegex matchAt: 2) asLowercase asSymbol;
				argument: (self msgRegex matchAt: 3);
				text: (self msgRegex matchAt: 4)].
	(self msgPingNoticeRegex matches: msgString)
		ifTrue: [
			^self new
				command: (self msgPingNoticeRegex matchAt: 1) asLowercase;
				text: (self msgPingNoticeRegex matchAt: 2)].
	^nil! !

!IRCGenericMessage class methodsFor: 'regex' stamp: 'FS 7/31/2008 14:54'!
resetMsgRegex
	msgRegex := (ReRegex  newForPattern: 
		':(.+?)\s(PRIVMSG|PONG|JOIN|PART|QUIT|NOTICE AUTH|NOTICE|\d{3})\s?(.*?) :(.*)').! !

!IRCGenericMessage class methodsFor: 'regex' stamp: 'FS 7/31/2008 14:54'!
resetPingNoticeRegex
	msgPingNoticeRegex := (ReRegex newForPattern:
		'^(PING|NOTICE AUTH|NOTICE) :(.*)').! !

!IRCGenericMessage class methodsFor: 'regex' stamp: 'FS 7/31/2008 14:54'!
resetRegexes
	self resetMsgRegex.
	self resetPingNoticeRegex.! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
argument
	^ argument! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
argument: anObject
	argument := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
command
	^ command! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
command: anObject
	command := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
sender
	^ sender! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
sender: anObject
	sender := anObject! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
text
	^ text! !

!IRCGenericMessage methodsFor: 'accessing' stamp: 'FS 7/25/2008 16:27'!
text: anObject
	text := anObject! !

Object subclass: #IRCProfile
	instanceVariableNames: 'nick userName realName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Client'!

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
nick
	^ nick! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
nick: anObject
	nick := anObject! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
realName
	^ realName! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
realName: anObject
	realName := anObject! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
userName
	^ userName! !

!IRCProfile methodsFor: 'accessing' stamp: 'FS 7/26/2008 15:26'!
userName: anObject
	userName := anObject! !

Object subclass: #LogDay
	instanceVariableNames: 'channel day log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

!LogDay class methodsFor: 'as yet unclassified' stamp: 'FS 8/12/2008 18:14'!
channel: aChannel day: aDay log: aLog
	^self new
		channel: aChannel;
		day: aDay;
		log: aLog.! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 18:12'!
channel
	^ channel! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 18:12'!
channel: anObject
	channel := anObject! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:24'!
day
	^ day! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:24'!
day: anObject
	day := anObject! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:24'!
log
	^ log! !

!LogDay methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:24'!
log: anObject
	log := anObject! !

Object subclass: #LogReader
	instanceVariableNames: 'channel timeRange customDate selectedChannels selectedTimeRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

!LogReader class methodsFor: 'as yet unclassified' stamp: 'FS 8/12/2008 15:17'!
defaultLogDirectory
	^FileDirectory default directoryNamed: 'IRC-logs'! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/11/2008 17:31'!
availableChannels
	^(self defaultLogDirectory directoryNames) 
		select: [:dir | dir first =  $#]. "only list channel name"! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/9/2008 17:36'!
channel
	((self selectedChannels isNil) or: [self selectedChannels size < 1])
		ifTrue: [^'']
		ifFalse: [^self selectedChannels at: 1]! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/6/2008 22:07'!
channel: anObject
	channel := anObject! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/9/2008 17:30'!
channelList
	^self availableChannels ! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/12/2008 18:09'!
convertCustomDateToDate
	"aString format: day.month.year (european format) e.g: 3.08.2007 for 3rd Aug 2008"
	| tokens |
	tokens := self customDate asString subStrings: '.'.
	^Date 
		year: (tokens at: 3) asInteger
		month: (tokens at: 2) asInteger
		day: (tokens at: 1) asInteger! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/12/2008 17:09'!
convertDateToDateInputFieldFormat: aDate
	^aDate printFormat: #(1 2 3 $. 1 1).! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:58'!
customDate
	^ customDate ifNil: [customDate := self convertDateToDateInputFieldFormat:  Date today]! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:10'!
customDate: anObject
	customDate := anObject! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/12/2008 15:17'!
defaultLogDirectory
	^self class defaultLogDirectory! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 18:19'!
fileForLogOnDate: aDate
	| dir fileName |
	dir := self monthDirectoryForDate: aDate.
	fileName := aDate dayOfMonth asString.
	(dir exists and: [dir fileExists: fileName])
		ifTrue:  [^dir fileNamed: fileName ].
	^nil! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/12/2008 18:02'!
log
	self timeRangeDictionary  
		at: self timeRange 
		ifPresent: [:symbol | ^self perform: symbol].
	^nil! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 18:11'!
logForCustomDate
	| date |
	date := self convertCustomDateToDate.
	^OrderedCollection with: (self logForDate: date)! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 18:14'!
logForDate: aDate
	| file log |
	file := self fileForLogOnDate: aDate.
	file ifNotNil: [log := file contentsOfEntireFile].
	^LogDay 
		channel: self channel 
		day: aDate 
		log: log! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 18:03'!
logForPastWeek
	| dates |
	dates := (Timespan
				starting: (Date today subtractDays: 7)
				ending: Date today) dates.
	^dates collect: [:d | self logForDate: d].! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 17:39'!
logForToday
	^OrderedCollection with: (self logForDate: Date today)! !

!LogReader methodsFor: 'files for time range' stamp: 'FS 8/12/2008 17:40'!
logForYesterday
	^OrderedCollection with: (self logForDate: Date yesterday)! !

!LogReader methodsFor: 'utils' stamp: 'FS 8/12/2008 16:28'!
monthDirectoryForDate: aDate
	^((self defaultLogDirectory
			directoryNamed: self channel)
			directoryNamed: aDate year asString)
			directoryNamed: aDate month name asString! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/8/2008 19:00'!
selectedChannels
	^ selectedChannels ifNil: [selectedChannels := OrderedCollection new]! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 15:03'!
selectedChannels: anObject
	selectedChannels := anObject.! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 15:10'!
selectedTimeRange
	^ selectedTimeRange ifNil: [selectedTimeRange := OrderedCollection new]! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 14:52'!
selectedTimeRange: anObject
	selectedTimeRange := anObject! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 14:54'!
timeRange
	((self selectedTimeRange isNil) or: [self selectedTimeRange size < 1])
		ifTrue: [^'']
		ifFalse: [^self selectedTimeRange at: 1]! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/11/2008 20:08'!
timeRange: anObject
	timeRange := anObject! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 17:43'!
timeRangeDictionary
	^Dictionary newFrom: {
		#Today -> #logForToday .
		#Yesterday -> #logForYesterday.
		#'Past Week' -> #logForPastWeek.
		#'Custom Date' -> #logForCustomDate}! !

!LogReader methodsFor: 'accessing' stamp: 'FS 8/12/2008 15:25'!
timeRangeList
	^self timeRangeDictionary keys.
		 ! !

Object subclass: #SocBot
	instanceVariableNames: 'server handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Core'!

!SocBot commentStamp: 'FS 7/4/2008 22:16' prior: 0!
A SocBot can connect to an IRC network in an automated way..

Instance Variables
	server:			is the connection to a server (must be a subclass of IRCClientAbstraction)
	directMessageSubscribers  are the handlers which want to get notified when the bot gets direct messages
	channelMessageSubscribers idem but for channel messages

Entry point of messages: #processPrivateMsg:
Example:
bot := SocBot newWithNick: 'Anna'.
bot connectTo: 'localhost'.
bot joinChannel: '#salonBleu'.
bot createHandler: 'SayHiHandler'.
bot createHandler: 'DicoHandler'.
bot identify: 'blopouille'.
bot disconnect.!

!SocBot class methodsFor: 'default values' stamp: 'FS 7/4/2008 12:04'!
defaultRealName
	^self defaultUserName ! !

!SocBot class methodsFor: 'default values' stamp: 'FS 7/4/2008 12:01'!
defaultUserName
	^'Squeak Bot'! !

!SocBot class methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 00:25'!
newWithNick: aNick
	^self new 
		nick: aNick;
		userName: self defaultUserName;
		realName: self defaultRealName;
		initializeDefaultHandlers.
! !

!SocBot class methodsFor: 'as yet unclassified' stamp: 'FS 7/31/2008 21:33'!
newWithNick: aNick admin: anAdminNick
	^(self newWithNick: aNick) 
			addAdmin: anAdminNick! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 23:03'!
activeHandlers
	^self handlers select: [:h | h active]! !

!SocBot methodsFor: 'admin' stamp: 'FS 7/31/2008 21:30'!
addAdmin: aNick
	(self findHandler: 'admin') addAdmin: aNick.! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:06'!
channels
	"channels in which the bot is connected"
	^self server channels! !

!SocBot methodsFor: 'network' stamp: 'FS 7/3/2008 22:00'!
connectTo: serverName 
	self server connectTo: serverName! !

!SocBot methodsFor: 'default values' stamp: 'FS 7/26/2008 15:10'!
defaultClientAbstractionClass
	^IRCClientWrapper! !

!SocBot methodsFor: 'default values' stamp: 'FS 7/16/2008 15:02'!
defaultHandlers
	^OrderedCollection new
		add: (LoggingHandler newForBot: self);
		add: (HelpHandler newForBot: self);
		add: (AdminHandler newForBot: self);
		add: (DicoHandler newForBot: self);
		yourself! !

!SocBot methodsFor: 'handlers' stamp: 'FS 7/31/2008 21:29'!
disableHandler: aHandlerNameString
	| handler |
	handler := self findHandler: aHandlerNameString.
	(handler shortName = 'admin') ifTrue: [^self].
	handler ifNotNil: [ handler disable].! !

!SocBot methodsFor: 'network' stamp: 'FS 8/2/2008 16:52'!
disconnect
	self handlers do: [:h | h disconnect].
	self server disconnect.! !

!SocBot methodsFor: 'handlers' stamp: 'FS 6/29/2008 11:59'!
enableHandler: aHandlerNameString
	| handler |
	handler := self findHandler: aHandlerNameString.
	handler ifNotNil: [ handler enable].! !

!SocBot methodsFor: 'handlers' stamp: 'FS 7/28/2008 12:35'!
findHandler: aHandlerNameString
	" for dicoHandler recognise: 
		- dicoHandler
		- dico"
	aHandlerNameString translateToLowercase.
	^self handlers  detect: [:each | 
			(each shortName = aHandlerNameString)
				or: [each className asLowercase = aHandlerNameString]]

		
! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/17/2008 13:00'!
forwardMessage: msg selector: selector
	"stop the chain when a handler answers true"
	self handlers detect: [:handler | (handler active) 
							and: [ handler perform: selector with: msg]]
				ifNone: []! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/12/2008 23:51'!
handlers
	^handlers! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
handlers: anObject
	handlers := anObject! !

!SocBot methodsFor: 'network' stamp: 'FS 6/23/2008 21:20'!
identify: password
	self privMsgTo: 'nickserv' text: ('identify ', password )! !

!SocBot methodsFor: 'initialize-release' stamp: 'FS 7/31/2008 13:22'!
initialize
	super initialize.
	self handlers: OrderedCollection new.
	self server: (self defaultClientAbstractionClass ) new.
	self server subscribeToPrivateMsg: self.
	self server subscribeToChannelActivityMsg: self.
	self server subscribeToServerCommandMsg: self.! !

!SocBot methodsFor: 'initialize-release' stamp: 'FS 7/13/2008 00:25'!
initializeDefaultHandlers
	self handlers: self defaultHandlers! !

!SocBot methodsFor: 'network' stamp: 'FS 7/10/2008 15:40'!
invite: channelName
	self privMsgTo: 'chanserv' text: ('invite ', channelName )! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/3/2008 21:59'!
isConnected
	self shouldBeImplemented! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/4/2008 18:25'!
isDirectMessage: msg
	^msg recipient = self nick.! !

!SocBot methodsFor: 'testing' stamp: 'FS 7/12/2008 23:54'!
isFromMe: msg
	"test whether or not a message comes from me..."
	^msg sender isNil or: [msg sender = self nick]! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 12:21'!
joinChannel: aString
	self server joinChannel: aString! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 21:03'!
leaveChannel: channelToLeave
	self server leaveChannel: channelToLeave.! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:03'!
nick
	^self server nick! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:03'!
nick: aString
	self server nick: aString! !

!SocBot methodsFor: 'network' stamp: 'FS 7/4/2008 18:02'!
privMsgTo: recipient text: aString
	"send a privmsg to the recipient (which can be an individual or a channel)"
	self server sendPrivateMsgTo: recipient text: aString! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/17/2008 14:03'!
processChannelActivityMsg: msg
	self forwardMessage: msg selector: #processChannelActivityMessage:.! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/28/2008 16:11'!
processPrivateMsg: msg
	"send by the server. A private message can be for channel or direct"
	| selector |
	(self isFromMe: msg) ifTrue: [^self].
	(self isDirectMessage: msg)
		ifTrue: [ selector := #processDirectMessage: ]
		ifFalse: [ selector := #processChannelMessage: ].
	self forwardMessage: msg selector: selector.! !

!SocBot methodsFor: 'message handling' stamp: 'FS 7/31/2008 16:41'!
processServerMsg: msg 
	self 
		forwardMessage: msg
		selector: #processServerMessage:! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/3/2008 22:38'!
realName
	^ self server realName! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:04'!
realName: aString
	self server realName: aString! !

!SocBot methodsFor: 'network' stamp: 'FS 7/31/2008 21:08'!
sendWhoIs: aNickName
	self server sendWhoIs: aNickName! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
server
	^ server! !

!SocBot methodsFor: 'accessing' stamp: 'FS 6/15/2008 21:22'!
server: anObject
	server := anObject! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:02'!
userName
	^ self server userName! !

!SocBot methodsFor: 'accessing' stamp: 'FS 7/4/2008 12:04'!
userName: aString
	self server userName: aString! !

WebStyle subclass: #BonobotStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Website'!

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:33'!
css1Body
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:47'!
css21Text
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:48'!
css22Links
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:48'!
css23Inputs
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:48'!
css25AutocompleteField
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:49'!
css26Popup
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:41'!
css27Menus
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/9/2008 20:49'!
css3Header
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/10/2008 18:23'!
css40NavigationBar
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/10/2008 18:23'!
css43Buckets
	^''! !

!BonobotStyle methodsFor: 'styles-screen-no' stamp: 'FS 8/10/2008 18:23'!
css44ContentHierarchy
	^''! !

!BonobotStyle methodsFor: 'styles-screen' stamp: 'FS 8/9/2008 20:34'!
cssAll
	^''! !

TestCase subclass: #AdminHandlerTest
	instanceVariableNames: 'bot adminHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!AdminHandlerTest methodsFor: 'admin auth test' stamp: 'FS 7/31/2008 20:44'!
fakeAddAdminFoo
	^IRCPrivateMessage newFromGenericMessage: 
		(IRCGenericMessage newFromString: ':fstephany PRIVMSG Anna :admin add admin Foo').! !

!AdminHandlerTest methodsFor: 'admin auth test' stamp: 'FS 7/31/2008 20:34'!
fakeEndOfWhoIsFoo
	^IRCServerMessage newFromGenericMessage: 
		(IRCGenericMessage newFromString: ':kubrick.freenode.net 318 Anna fstephany :End of /WHOIS list.').		
	
	! !

!AdminHandlerTest methodsFor: 'admin auth test' stamp: 'FS 7/31/2008 20:34'!
fakeIsIdentifiedFoo
	^IRCServerMessage newFromGenericMessage: 
		(IRCGenericMessage newFromString: ':kubrick.freenode.net 320 Anna fstephany :is identified to service').		
	
	! !

!AdminHandlerTest methodsFor: 'setUp - tear down' stamp: 'FS 7/31/2008 21:38'!
setUp
	bot := FakeBot new.
	bot nick: 'Anna'.
	adminHandler := AdminHandler newForBot: bot.
	adminHandler addAdmin: 'fstephany'.! !

!AdminHandlerTest methodsFor: 'setUp - tear down' stamp: 'FS 8/1/2008 19:58'!
tearDown
	bot := nil.
	adminHandler := nil! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 6/30/2008 19:07'!
testAddAdmin
	| initialSize |
	initialSize := adminHandler admins size.
	
	adminHandler addAdmin: 'Ken'.
	self assert: (adminHandler admins size = ( initialSize + 1)).
	self assert: (adminHandler admins includes: 'Ken') "Ken is a valid key"! !

!AdminHandlerTest methodsFor: 'admin auth test' stamp: 'FS 7/31/2008 21:00'!
testAdminAuthentificationFailed
	| msg whoIsAnswer |
	msg := self fakeAddAdminFoo.	
	whoIsAnswer := self fakeEndOfWhoIsFoo.
			
	self deny: [adminHandler admins includes: 'Foo'] . "Foo is not yet admin"
	adminHandler processDirectMessage:  msg.
	self deny: [adminHandler admins includes: 'Foo'].
	adminHandler processServerMessage: whoIsAnswer.
	self deny: [adminHandler admins includes: 'Foo'].
	! !

!AdminHandlerTest methodsFor: 'admin auth test' stamp: 'FS 7/31/2008 21:00'!
testAdminAuthentificationSucces
	| msg whoIsAnswer identifiedAnswer |
	msg := self fakeAddAdminFoo.	
	whoIsAnswer := self fakeEndOfWhoIsFoo.
	identifiedAnswer := self fakeIsIdentifiedFoo.
			
	self deny: [adminHandler admins includes: 'Foo']. "Foo is not yet admin"
	adminHandler processDirectMessage:  msg.
	self deny: [adminHandler admins includes: 'Foo'].
	adminHandler processServerMessage: identifiedAnswer.
	adminHandler processServerMessage: whoIsAnswer.
	self assert: [adminHandler admins includes: 'Foo']! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 7/9/2008 22:14'!
testIsDisableCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'disable') regex.
	self 
		assert: (reRegex matches: 'disable SayHiHandler');
		assert: (reRegex matches: 'DISABLE sayhihandler');
		deny: (reRegex matches: 'admin disable SayHiHandler');
		deny: (reRegex matches: ' disable Blopblop ').! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 7/9/2008 22:15'!
testIsEnableCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'enable') regex.
	self 
		assert: (reRegex matches: 'enable SayHiHandler');
		assert: (reRegex matches: 'ENABLE  SayHiHandler');
		deny: (reRegex matches: 'admin word enable SayHiHandler').
! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 7/9/2008 22:16'!
testIsIdentifyCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'identify') regex.
	self 
		assert: (reRegex matches: 'identify password');
		deny: (reRegex matches: 'admin identify').
	! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 7/9/2008 22:16'!
testIsJoinCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'join') regex.
	self 
		assert: (reRegex matches: 'join #squeak');
		deny: (reRegex matches: 'joins #squeak').! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 7/9/2008 22:17'!
testIsNewAdminCommand
	"see AdminHandler class definition or valid msgs"
	| reRegex |
	reRegex := (adminHandler commands at: 'add admin') regex.
	self
		assert: (reRegex matches: 'add admin Ken');
		deny: (reRegex matches: 'add adminKen')! !

!AdminHandlerTest methodsFor: 'regex command tests' stamp: 'FS 6/29/2008 16:42'!
testProcessMessage
	! !

TestCase subclass: #DicoHandlerTest
	instanceVariableNames: 'bot dicoHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/24/2008 18:08'!
fillHandlerWithDefinition
	| msg1 msg2 msg3 |
	msg1 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember squeak is a smalltalk implementation'.
	msg2 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember belgium is a tiny country'.
	msg3 := IRCPrivateMessage 
		sender: 'test'
		recipient: 'Anna'
		text: 'Anna; remember tea is the best drink ever'.
	dicoHandler
		processDirectMessage: msg1;
		processDirectMessage: msg2;
		processDirectMessage: msg3! !

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/15/2008 16:59'!
isGeneralDefinitionRequest: text
	^dicoHandler generalRequestPattern matches: text
		
		
	! !

!DicoHandlerTest methodsFor: 'utilities' stamp: 'FS 7/15/2008 16:56'!
isWhatIsDefinitionRequest: text
	^dicoHandler whatIsRequestPattern matches: text
		
		
	! !

!DicoHandlerTest methodsFor: 'testing' stamp: 'FS 8/2/2008 15:30'!
setUp
	bot := FakeBot new.
	bot nick: 'Anna'.
	dicoHandler := DicoHandler newForBot: bot.
	dicoHandler repositoryDirectory: 'IRC-TestRepo'.
	dicoHandler deleteRepository.! !

!DicoHandlerTest methodsFor: 'testing' stamp: 'FS 8/2/2008 15:30'!
tearDown
	MagmaSession disconnectAndCloseAllConnectedSessions.
	dicoHandler deleteRepository.
	bot := nil.
	dicoHandler := nil.! !

!DicoHandlerTest methodsFor: 'general tests' stamp: 'FS 7/24/2008 18:08'!
testAnswerDefinition
	| msg1 msg2 msg3 msgCount |
	self fillHandlerWithDefinition.
	msgCount := bot outgoingMessages size.
	"simulates new messages"
	msg1 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: 'Anna'
		text: 'what is squeak?'.
	msg2 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, what is belgium ?'.
	msg3 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, what is key that doesnt exist ?'.
	dicoHandler processDirectMessage: msg1.
	dicoHandler processChannelMessage: msg2.
	dicoHandler processChannelMessage: msg3.
	self assert: bot outgoingMessages size = (msgCount + 3)! !

!DicoHandlerTest methodsFor: 'persistence tests' stamp: 'FS 8/1/2008 15:33'!
testCreateRepository
	| dir |
	dir := dicoHandler repositoryDirectory.
	self deny: (dir exists).
	dicoHandler createRepository.
	self assert: (dir exists).! !

!DicoHandlerTest methodsFor: 'persistence tests' stamp: 'FS 8/1/2008 19:39'!
testDisablePersistency
	dicoHandler enablePersistency.
	dicoHandler disablePersistency.
	self
		deny: (dicoHandler persistent);
		assert: (dicoHandler maSession isNil).! !

!DicoHandlerTest methodsFor: 'persistence tests' stamp: 'FS 8/1/2008 15:39'!
testEnablePersistency
	self deny: (dicoHandler persistent).
	dicoHandler enablePersistency.
	self
		assert: (dicoHandler persistent);
		assert: (dicoHandler repositoryDirectory exists);
		assert: (dicoHandler maSession isNil not);
		assert: (dicoHandler maSession isConnected).! !

!DicoHandlerTest methodsFor: 'regexes tests' stamp: 'FS 7/16/2008 14:23'!
testGeneralRequest
	| matcher |
	matcher := dicoHandler generalRequestPattern.
	{ 'Anna, squeak?'.
		'Anna: squeak ?'.
		'Anna, squeak'.
		'Anna: squeak? '.
		'Anna squeak ' } 
	do: [:each |
			matcher matches: each.
			 self assert: ((matcher matchAt: 1) = 'squeak')].! !

!DicoHandlerTest methodsFor: 'regexes tests' stamp: 'FS 7/15/2008 17:01'!
testIsGeneralDefinitionRequest
	self 
		assert: (self  isGeneralDefinitionRequest: 'Anna, Monticello ?');
		assert: (self  isGeneralDefinitionRequest: 'Anna, monticello');
		assert: (self  isGeneralDefinitionRequest: 'Anna    ; Smalltalk?');
		assert: (self  isGeneralDefinitionRequest: 'Anna the bot Smalltalk?');
		deny: (self  isGeneralDefinitionRequest: 'plane?');
		deny: (self  isGeneralDefinitionRequest: 'what is smalltalk Anna ?').
		
		
		
	! !

!DicoHandlerTest methodsFor: 'regexes tests' stamp: 'FS 7/8/2008 14:32'!
testIsNewDefinition
	self
		assert: (dicoHandler isNewDefinition: 'Anna REMEMBER wikipedia is an encyclopedia');
		assert: (dicoHandler isNewDefinition: 'Anna: please remember smalltalk is a great environment');
		assert: (dicoHandler isNewDefinition: 'Anna, remember this is not that ');
		deny: (dicoHandler isNewDefinition: 'Anna i tell you java is great' );
		deny: (dicoHandler isNewDefinition: ' Anna, remember squeak is a smalltalk').! !

!DicoHandlerTest methodsFor: 'regexes tests' stamp: 'FS 7/15/2008 16:59'!
testIsWhatIsDefinitionRequest
	self 
		assert: (self  isWhatIsDefinitionRequest: 'Anna, WHAT is Monticello ?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna: what is a plane?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna what is Smalltalk?');
		assert: (self  isWhatIsDefinitionRequest: 'Anna the bot what is Smalltalk?');
		deny: (self  isWhatIsDefinitionRequest: 'what is a plane  ?');
		deny: (self  isWhatIsDefinitionRequest: 'what is smalltalk Anna ?').
		
		
		
	! !

!DicoHandlerTest methodsFor: 'general tests' stamp: 'FS 7/24/2008 18:08'!
testSaveNewDefinition
	| msg1 msg2 |
	msg1 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: '#squeak'
		text: 'Anna, remember squeak is a smalltalk implementation'.
	msg2 := IRCPrivateMessage 
		sender: 'unittest'
		recipient: 'Anna'
		text: 'please remember JAVA is a programming language'.
	dicoHandler
		processChannelMessage: msg1;
		processDirectMessage: msg2.
	self
		assert: dicoHandler definitions size = 2;
		assert: (dicoHandler definitions at: 'squeak') = 'a smalltalk implementation';
		assert: (dicoHandler definitions at: 'java') = 'a programming language'! !

!DicoHandlerTest methodsFor: 'regexes tests' stamp: 'FS 7/16/2008 10:12'!
testWhatIsRequest
	| matcher |
	matcher := dicoHandler whatIsRequestPattern.
	{ 'Anna, what is squeak?'.
		'Anna, what is squeak ?'.
		'Anna, what is squeak'.
		'Anna, what is squeak? '.
		'Anna, what is squeak ' } 
	do: [:each |
			matcher matches: each.
			 self assert: ((matcher matchAt: 1) = 'squeak')].! !

TestCase subclass: #FileChannelLoggerTest
	instanceVariableNames: 'logger testDirectory channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!FileChannelLoggerTest commentStamp: 'FS 7/17/2008 10:55' prior: 0!
This test creates directory in the image's default directory.!

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 15:47'!
setUp
	testDirectory := FileDirectory default directoryNamed: 'IRC-test-logger'.
	channel :=  '#squeak-test'.
	logger := FileChannelLogger new.
	logger channel: channel.
	logger directory: testDirectory .
	logger initializeStream.! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 19:59'!
tearDown
	logger closeStream.
	logger := nil.
	testDirectory recursiveDelete..! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:33'!
testFormatSimpleMessage
	| msg result regex |
	msg := IRCPrivateMessage sender: 'bob' recipient: channel text: 'this is a text'.
	result := logger formatSimpleMessage: msg.
	regex := ReRegex newForPattern: '(.*?)\t(.*?)\t(.*)'.
	self 
		assert: (regex matches: result);
		assert: ((regex matchAt: 2) = 'bob' );
		assert: ((regex matchAt: 3) = 'this is a text').
! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/16/2008 16:16'!
testInitialize
	| dir |
	dir := testDirectory directoryNamed: (channel).
	self assert: (logger dateOfStream = Date today).
	self assert: (logger stream atEnd).
	self assert: (dir exists).! !

!FileChannelLoggerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:08'!
testLogSimpleMessage
	| msg dir today fileStream |
	today := Date today.
	msg := IRCPrivateMessage 
		sender: 'bob'
		recipient: channel
		text: 'this is a text'.
	logger logSimpleMessage: msg.
	dir := ((testDirectory directoryNamed: channel) directoryNamed: today year asString) directoryNamed: today month name asString.
	self assert: (dir fileExists: today dayOfMonth asString).
	fileStream := dir readOnlyFileNamed: today dayOfMonth asString.
	fileStream contentsOfEntireFile = (logger formatSimpleMessage: msg).
	fileStream close! !

TestCase subclass: #HelpHandlerTest
	instanceVariableNames: 'bot helpHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!HelpHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 15:06'!
setUp
	bot := FakeBot new.
	helpHandler := HelpHandler newForBot: bot.! !

!HelpHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 15:32'!
tearDown
	bot := nil.
	helpHandler := nil.! !

!HelpHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 7/9/2008 15:27'!
testHelpPattern
	| matcher |
	matcher := helpHandler helpPattern.
	self assert: (matcher matches: 'anna, help').
	self assert: (matcher matches: 'Anna, help').
	self assert: (matcher matches: 'Anna,	help'). "tabulation"
	self assert: (matcher matches: 'Anna,  help').
	self assert: (matcher matches: 'anna : help').
	self assert: (matcher matches: 'anna :   help').
	self assert: (matcher matches: 'anna : help admin').
	self assert: (matcher matches: 'anna ; help').
	self deny: (matcher matches: 'brol truc chouette').
	self deny: (matcher matches: 'help').
	self deny: (matcher matches: 'anna blop help').! !

TestCase subclass: #IRCChannelActivityMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCChannelActivityMessageTest methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 19:56'!
testNewFromJoinString
	| string generic activity |
	string := ':fstephany!!n=fstephan@ip.adsl-dyn.isp.be JOIN :#squeak'.
	generic := IRCGenericMessage newFromString: string.
	activity := IRCChannelActivityMessage newFromGenericMessage: generic.
	self
		assert: activity channel = '#squeak';
		assert: activity user = 'fstephany';
		assert: activity command = #join;
		assert: activity text = ''! !

!IRCChannelActivityMessageTest methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 19:56'!
testNewFromPartString
	| string generic activity |
	string := ':fstephany!!n=fstephan@253.adsl-dyn.isp.be PART #squeak :"i leave!!"'.
	generic := IRCGenericMessage newFromString: string.
	activity := IRCChannelActivityMessage newFromGenericMessage: generic.
	self
		assert: activity channel = '#squeak';
		assert: activity user = 'fstephany';
		assert: activity command = #part;
		assert: activity text = '"i leave!!"'! !

!IRCChannelActivityMessageTest methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 19:56'!
testNewFromQuitString
	| string generic activity |
	string := ':fstephany!!n=fstephan@ip.adsl-dyn.isp.be QUIT :"Zzz"'.
	generic := IRCGenericMessage newFromString: string.
	activity := IRCChannelActivityMessage newFromGenericMessage: generic.
	self
		assert: activity channel = '';
		assert: activity user = 'fstephany';
		assert: activity command = #quit;
		assert: activity text = '"Zzz"'! !

TestCase subclass: #IRCChannelTest
	instanceVariableNames: 'channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCChannelTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 18:00'!
setUp
	channel := IRCChannel newForName: '#squeak'! !

!IRCChannelTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 18:00'!
tearDown
	channel := nil! !

!IRCChannelTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 18:21'!
testAddNick
	self
		assert: (channel users size = 0);
		assert: (channel ops size = 0).
		
	channel addNick: 'fstephany'.
	self 
		assert: (channel users size = 1);
		assert: (channel ops size = 0).
	channel addNick: '@Ken'.
	self 
		assert: (channel users size = 1);
		assert: (channel ops size = 1);
		assert: (channel ops includes: 'Ken').
		
	channel addNick: 'fstephany'.
	self 
		assert: (channel users size = 1);
		assert: (channel ops size = 1).! !

!IRCChannelTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 19:56'!
testRemoveNick
	channel addNick: 'fstephany'.
	channel removeNick: 'fstephany'.
	channel removeNick: 'nonExistentNick'.
	self deny: (channel users includes: 'fstephany').! !

TestCase subclass: #IRCClientConnectionTest
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:42'!
setUp
	client := IRCClientConnection new.! !

!IRCClientConnectionTest methodsFor: 'as yet unclassified' stamp: 'FS 7/24/2008 18:43'!
testInitialize
	self 
		assert: (client socket isNil);
		assert: (client messagesToSend size = 0).! !

TestCase subclass: #IRCClientWrapperTest
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCClientWrapperTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 16:10'!
setUp
	client := IRCClientWrapper new.! !

!IRCClientWrapperTest methodsFor: 'as yet unclassified' stamp: 'FS 8/4/2008 16:23'!
tearDown
	client := nil.! !

!IRCClientWrapperTest methodsFor: 'server command tests' stamp: 'FS 8/4/2008 16:24'!
testExtractChannelName
	| msg1 msg2 |
	msg1 := IRCGenericMessage 
				newFromString: ':localhost. 353 tulipe = #salonBleu :tulipe @fstephany ken john'.
	msg2 := IRCGenericMessage
				newFromString: ':leguin.freenode.net 353 tulipe = #gsoc :tulipe eseidel MattSS RazZziel alanp__ @Catfish_Man jaguarandi wsfulton JLafont Revan76 ArthurRandolph scrouaf bcarlyon|laptop guyvdb zxiiro Jberg88 spearce L4m3r k0p harlan__ andrecastelo oy mrMister Mek The_PHP_Jedi cwgordon7 TobiasFar sioraiocht astratto RafaelNobrega vcgomes KillerX pombreda luisfelipe unsolo_ @jbailey dhaun Cpudan80 thiagoss pdherbemont fargiolas|afk sidnei ankitg_ samuel_l jpds tcoppi brion spectie @kblin rbp bugQ playya'.			
				
	self assert: ((client extractChannelName: msg1 argument) = '#salonBleu').
	self assert: ((client extractChannelName: msg2 argument) = '#gsoc').! !

!IRCClientWrapperTest methodsFor: 'server command tests' stamp: 'FS 8/4/2008 17:43'!
testExtractNicksFrom
	| msg collection |
	msg := 'tulipe  fargiolas|afk ankitg_ samuel_l jpds @kblin rbp bugQ playya'.			
	collection := 	client extractNicksFrom: msg.
	self 
		assert: (collection size = 9);
		assert: (collection includes: 'tulipe');
		assert: (collection includes: 'ankitg_');
		assert: (collection includes: '@kblin').! !

!IRCClientWrapperTest methodsFor: 'server command tests' stamp: 'FS 8/5/2008 21:29'!
testProcessLoggedIn
	| msg |
	msg := IRCGenericMessage newFromString: ':calvino.freenode.net 901 squeakbot squeakbot n=Squeak .be :You are now logged in. (id squeakbot, username n=Squeak, hostname adsl-dyn.isp.belgacom.be)'.
	self deny: (client identified).
	client processMessage: msg.
	self assert: (client identified).! !

!IRCClientWrapperTest methodsFor: 'server command tests' stamp: 'FS 8/4/2008 20:42'!
testProcessNameReply
	| msg rawMsg channel|
	rawMsg := ':localhost. 353 tulipe = #salonBleu :tulipe @fstephany ken john'.
	msg := IRCServerMessage newFromGenericMessage: 
					(IRCGenericMessage newFromString: rawMsg).
	client confirmJoinChannel: '#salonBleu'.
	channel := client channelWithName: '#salonBleu'.
	client processNameReply: msg.
	self assert: (channel users size = 3).
	self assert: (channel ops size = 1).! !

!IRCClientWrapperTest methodsFor: 'notices messages test' stamp: 'FS 8/5/2008 20:56'!
testProcessNoticeIdentifiedMessage
	| msg |
	msg := IRCGenericMessage newFromString: 
		':NickServ!!services@localhost NOTICE fstephany :Password accepted - you are now recognized.'.		
	self deny: (client identified).
	client processMessage: msg.
	self assert: (client identified)! !

TestCase subclass: #IRCGenericMessageTest
	instanceVariableNames: 'msgRegex msgPingNoticeRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCGenericMessageTest methodsFor: 'as yet unclassified' stamp: 'FS 7/31/2008 15:25'!
setUp
	IRCGenericMessage resetRegexes.
	msgRegex := IRCGenericMessage msgRegex.
	msgPingNoticeRegex := IRCGenericMessage msgPingNoticeRegex.! !

!IRCGenericMessageTest methodsFor: 'msgRegex tests' stamp: 'FS 7/31/2008 15:32'!
testMsgRegex1
	self
		assert: (msgRegex matches: ':kikoolol.local NOTICE AUTH :*** Looking up your hostname...');
		assert: (msgRegex matchAt: 1) = 'kikoolol.local';
		assert: (msgRegex matchAt: 2) = 'NOTICE AUTH';
		assert: (msgRegex matchAt: 3) = '';
		assert: (msgRegex matchAt: 4) = '*** Looking up your hostname...'! !

!IRCGenericMessageTest methodsFor: 'msgRegex tests' stamp: 'FS 7/31/2008 15:32'!
testMsgRegex2
	self
		assert: (msgRegex matches: ':fstephany!!fstephany@i.love.debian.org PRIVMSG tulipe :Hello!!');
		assert: (msgRegex matchAt: 1) = 'fstephany!!fstephany@i.love.debian.org';
		assert: (msgRegex matchAt: 2) = 'PRIVMSG';
		assert: (msgRegex matchAt: 3) = 'tulipe';
		assert: (msgRegex matchAt: 4) = 'Hello!!'! !

!IRCGenericMessageTest methodsFor: 'msgRegex tests' stamp: 'FS 7/31/2008 15:32'!
testMsgRegex3
	self
		assert: (msgRegex matches: ':kikoolol.local 421 tulipe /msg :Unknown command');
		assert: (msgRegex matchAt: 1) = 'kikoolol.local';
		assert: (msgRegex matchAt: 2) = '421';
		assert: (msgRegex matchAt: 3) = 'tulipe /msg';
		assert: (msgRegex matchAt: 4) = 'Unknown command'! !

!IRCGenericMessageTest methodsFor: 'msgRegex tests' stamp: 'FS 7/31/2008 15:35'!
testMsgRegex4
	self deny: (msgRegex matches: ':kikoolol.local 004 Anna kikoolol.local hybrid-7.2.2.dfsg.2-debian.3 DGabcdfgiklnorsuwxyz biklmnopstveIh bkloveIh').
	self deny: (msgRegex matches: 'NOTICE AUTH :*** Looking up your hostname...')! !

!IRCGenericMessageTest methodsFor: 'msgRegex tests' stamp: 'FS 7/31/2008 15:36'!
testMsgRegex5
	| msg |
	msg := ':fstephany!!n=fstephan@5.194-242-81.adsl-dyn.isp.belgacom.be PRIVMSG squeakbot :admin join'.
	self
		assert: (msgRegex matches: msg);
		assert: (msgRegex matchAt: 1) = 'fstephany!!n=fstephan@5.194-242-81.adsl-dyn.isp.belgacom.be';
		assert: (msgRegex matchAt: 2) = 'PRIVMSG';
		assert: (msgRegex matchAt: 3) = 'squeakbot';
		assert: (msgRegex matchAt: 4) = 'admin join'! !

!IRCGenericMessageTest methodsFor: 'testMsgPingNotice' stamp: 'FS 7/31/2008 15:34'!
testPingNoticeRegex
self
		assert: (msgPingNoticeRegex matches: 'NOTICE AUTH :*** Looking up your hostname...');
		assert: ((msgPingNoticeRegex matchAt: 1) = 'NOTICE AUTH');
		assert: ((msgPingNoticeRegex matchAt: 2) = '*** Looking up your hostname...').! !

TestCase subclass: #IRCServerMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!IRCServerMessageTest methodsFor: 'as yet unclassified' stamp: 'FS 7/31/2008 15:20'!
testNewFromString1
	| msg genericMsg serverMsg |
	msg := ':kubrick.freenode.net 320 tulipe fstephany :is identified to service'.
	genericMsg := IRCGenericMessage newFromString: msg.
	serverMsg := IRCServerMessage newFromGenericMessage: genericMsg.
	self 
		assert: (serverMsg command = '320');
		assert: (serverMsg argument = 'tulipe fstephany');
		assert: (serverMsg text = 'is identified to service').! !

TestCase subclass: #LoggingHandlerTest
	instanceVariableNames: 'handler bot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 15:08'!
addUser: nick inChannel: chan
	| channel |
	channel := bot channels  detect: [:c | c channelName = chan].
	channel ifNotNil: [channel addUser: nick].! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:45'!
setUp
	bot := FakeBot new.
	handler := LoggingHandler new.
	handler bot: bot.
	handler loggerClass: FakeChannelLogger.
	handler initializeLoggerForBot.
	handler logChannel: 'direct'.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/2/2008 15:32'!
tearDown
	bot := nil.
	handler := nil.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:37'!
testDirectMessage
	| msg |
	msg := IRCPrivateMessage newFromGenericMessage: (
		IRCGenericMessage newFromString: ':fstephany!!n=fstephan@adsl.be PRIVMSG Anna :Yop anna').
	handler processDirectMessage: msg.
	
	self assert: (handler channelLoggers at: 'direct') activityLogged size = 0.
	self assert: (handler channelLoggers at: 'direct') messagesLogged size = 1.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:40'!
testInitialize
	" + 1 because thers an extra channelLogger for direct messages"
	self assert: (handler channelLoggers size = (bot channels size + 1)).
	self assert: (handler loggerClass = FakeChannelLogger).! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 14:53'!
testProcessChannelActivityMessageJoin
	| msg |
	msg := IRCChannelActivityMessage newFromGenericMessage: (
		IRCGenericMessage newFromString: ':fstephany!!n=fstephan@adsl.be JOIN :#squeak').
	handler processChannelActivityMessage: msg.
	
	self assert: (handler channelLoggers at: '#squeak') activityLogged size = 1.
	self assert: (handler channelLoggers at: '#aida') messagesLogged size = 0.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 14:58'!
testProcessChannelActivityMessagePart
	| msg |
	msg := IRCChannelActivityMessage newFromGenericMessage: (
		IRCGenericMessage newFromString: ':fstephany!!n=fstephan@adsl-dyn.be PART #squeak :"byebye"').
	handler processChannelActivityMessage: msg.
	
	self assert: (handler channelLoggers at: '#squeak') activityLogged size = 1.
	self assert: (handler channelLoggers at: '#aida') messagesLogged size = 0.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/5/2008 15:03'!
testProcessChannelActivityMessageQuit
	| msg |
	msg := IRCChannelActivityMessage newFromGenericMessage: (
		IRCGenericMessage newFromString: ':fstephany!!n=fstephan@adsl.be QUIT :Client Quit').
	self addUser: 'fstephany' inChannel: '#squeak'.
	handler processChannelActivityMessage: msg.
	self assert: (handler channelLoggers at: '#squeak') activityLogged size = 1.
	self assert: (handler channelLoggers at: '#aida') messagesLogged size = 0.! !

!LoggingHandlerTest methodsFor: 'as yet unclassified' stamp: 'FS 8/11/2008 11:40'!
testProcessChannelMessage1
	| msg1 msg2 msg3 |
	msg1 := IRCPrivateMessage sender: 'bob' recipient: '#squeak' text: 'message test'.
	msg2 := IRCPrivateMessage sender: 'alice' recipient: '#aida' text: 'Tililii'.
	msg3 := IRCPrivateMessage sender: 'alice' recipient: 'Anna' text: 'should not be logged'.
	handler
		processChannelMessage: msg1;
		processChannelMessage: msg2;
		processChannelMessage: msg3.
	self assert: (handler channelLoggers at: '#squeak') messagesLogged size = 1.
	self assert: (handler channelLoggers at: '#aida') messagesLogged size = 1.! !

TestCase subclass: #ReRegexTest
	instanceVariableNames: 'reRegex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!ReRegexTest commentStamp: 'FS 7/7/2008 21:39' prior: 0!
See the ReTest class for a morecomplete testing
!

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/15/2008 16:23'!
testMatchAt
	| p |
	p := ReRegex newForPattern: 'Anna (.*) and (.*)'.	
	self 
		assert: (p matches: 'Anna  and drinks');
		assert: ((p matchAt: 1) = '');	

		assert: (p matches: 'Anna eats and drinks');
		assert: ((p matchAt: 1) = 'eats');
		assert: ((p matchAt: 2) = 'drinks');
		assert: ((p matchAt: 3) = nil);
		deny: (p matches: 'Annaand');
		assert: ((p matchAt: 1) = nil);
		deny: (p matches: 'Anna and drinks'). "only 1 space"! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/7/2008 21:37'!
testMatches
	| p |
	p := ReRegex newForPattern: '^Anna'.	
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		deny: (p matches: 'drink');
		deny: (p matches: 'this is Anna');
		deny: (p matches: 'anna');
		deny: (p matches: 'anna ').
		! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:39'!
testMatchesCaseLess
	| p |
	p := ReRegex newForPattern: '(?i)^Anna'.	
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		assert: (p matches: 'anna');
		assert: (p matches: 'ANNA');
		assert: (p matches: 'anna blop').
		! !

!ReRegexTest methodsFor: 'as yet unclassified' stamp: 'FS 7/8/2008 11:57'!
testMatchesCaseLess2
	| p |
	p := ReRegex newForPattern: '^Anna'.
	p setCaseInsensitive.
	self 
		assert: (p matches: 'Anna');
		assert: (p matches: 'Anna and you');
		assert: (p matches: 'anna');
		assert: (p matches: 'ANNA');
		assert: (p matches: 'anna blop').
		! !

TestCase subclass: #SocBotTest
	instanceVariableNames: 'localBot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRCBot3-Tests'!

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 7/24/2008 18:08'!
createFakeIRCMessage
	^ IRCPrivateMessage 
		sender: 'fstephany'
		recipient: 'Anna'
		text: 'This is the text'! !

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 6/29/2008 14:41'!
createFakeIRCProtocolMessage
	| message |
	message := IRCProtocolMessage fromString:
		':fstephany!!~fstephany@localhost. PRIVMSG #salonBleu :salut Anna'.
		
	^message! !

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 7/4/2008 22:57'!
setUp
	localBot := SocBot newWithNick: 'Anna'.! !

!SocBotTest methodsFor: 'fixtures' stamp: 'FS 8/2/2008 15:33'!
tearDown
	localBot := nil.! !

!SocBotTest methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:12'!
testActiveHandlers
	| activeSize |
	activeSize := localBot activeHandlers size. 
	localBot disableHandler: 'HelpHandler'.
	self assert: ( localBot activeHandlers size = (activeSize -1)).
	localBot enableHandler: 'HelpHandler'.
	self assert: ( localBot activeHandlers size = activeSize).! !

!SocBotTest methodsFor: 'as yet unclassified' stamp: 'FS 7/13/2008 01:14'!
testProcessMessage
	| msg fakeHandler |
	msg := self createFakeIRCMessage.
	localBot handlers: (OrderedCollection new 
		add: (FakeHandler newForBot: localBot);
		yourself).
	
	fakeHandler := localBot findHandler: 'FakeHandler'.
	localBot processPrivateMsg: msg.
	self assert: (fakeHandler messages size = 1).
	
	localBot disableHandler: 'FakeHandler'.
	localBot processPrivateMsg: msg. "this msg shouldnt be forwarded to fakeHandler"
	self assert: (fakeHandler messages size = 1).
	! !
